// FileManager.h: interface for the FileManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEMANAGER_H__6AE0E08F_98F0_4204_ACD4_4A7E6F8EAF29__INCLUDED_)
#define AFX_FILEMANAGER_H__6AE0E08F_98F0_4204_ACD4_4A7E6F8EAF29__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <afxtempl.h>
#include <afxinet.h>


#define IMAGE_TYPE_ERROR	0
#define IMAGE_TYPE_BMP		1
#define IMAGE_TYPE_JPG		3
#define IMAGE_TYPE_PNG		4
#define IMAGE_TYPE_PCX		5
#define IMAGE_TYPE_TIFF		6
#define IMAGE_TYPE_TGA		14


struct ImageInfo 
{
	LPBYTE hOriginalRGB ; 
	UINT nWidth ; 
	UINT nHeight ; 
	UINT nRowStride ; 
	UINT nImageType ; 
	UINT nBytesPixel ; 
	
	int nJpegQuality ; 
	size_t iSize ; 
	LPCWSTR szErrorMsg ; 
	TCHAR szFile [MAX_PATH] ; 

	
	ImageInfo () 
	{
		hOriginalRGB = NULL ; 
		szErrorMsg = NULL ; 
		iSize = 0; 
	}

	void SetImage (LPBYTE pImg,size_t iSize) 
	{
		 
		if(hOriginalRGB != NULL)
			delete [] hOriginalRGB ; 
		
		hOriginalRGB = DEBUG_NEW BYTE[iSize] ;
		memcpy(hOriginalRGB,pImg,iSize) ; 

		
	}
	~ImageInfo () 
	{
		delete [] hOriginalRGB ; 
	}
};


class CFileManager  
{
public:
	CFileManager();
	bool OpenImageFile (LPCWSTR pszFileName,ImageInfo* info ); 
	bool SaveImageFile (LPCWSTR pszFileName,ImageInfo* info) ; 
	CString FileOptions (BOOL m_bFileName,BOOL m_bSkipped,LPCWSTR pszFileName,
						 CString& m_strFolderPath,int nOperation); 

	UINT SetRequestedFileSize (UINT nMaxSize,ImageInfo& info) ; 
	LPBYTE GetThumbnail (LPCWSTR srcFile,UINT& w,UINT& h ) ; 
	UINT GetFileType (LPCWSTR lpsFile) ;
	BOOL GetDims(CString strFile,UINT32* w,UINT32* h) ; 

	bool IsSuportedType (LPCWSTR pszFileName) ; 
	HBITMAP ExtractThumb(LPCWSTR szFile) ; 
	int GetEXIFString(LPCTSTR pFileName, UINT32 nTag) ; 



	virtual ~CFileManager();

};

#endif // !defined(AFX_FILEMANAGER_H__6AE0E08F_98F0_4204_ACD4_4A7E6F8EAF29__INCLUDED_)

