#include "StdAfx.h"
#include ".\gdibitmap.h"

IMPLEMENT_DYNAMIC(CGDIDialog,CGdiObject)

BOOL CGDIDialog::ReadPGF(LPCWSTR szSkinFile)
{
	return GDIBitmap::ReadPGF(szSkinFile) ; 

}
void CGDIDialog::Draw(CDC* dcMemory,BOOL bAlpha)
{
	GDIBitmap::Draw(dcMemory,NORMAL,bAlpha) ; 

}
IMPLEMENT_DYNAMIC(CGDIButton,CGdiObject)  
BOOL CGDIButton::ReadPGF(LPCWSTR szSkinFile) 
{
	m_szSkinFile = szSkinFile ; 

	RGBQUAD Palette[256];

	USES_CONVERSION ; 
 
	TCHAR psPath [MAX_PATH] ; 
	CUtils::GetShortPathName(szSkinFile,psPath) ; 

	HISSRC hSrc = IS40_OpenFileSource(W2A(psPath)) ;  
	
	IS40_Seek(hSrc, 0, 0) ; 
	
	UINT32 uDataLen = sizeof(POINT) ; 

	BYTE* pHeader =  DEBUG_NEW BYTE[uDataLen] ;
	IS40_Read(hSrc,pHeader,uDataLen) ; 

	IS40_Seek(hSrc, uDataLen, 0) ; 

	m_hOriginalRGB = IS40_ReadPNG(hSrc, &w, &h, 32, Palette,0);
	if (m_hOriginalRGB == NULL) 
	{
		LPCWSTR szError = _T("Failed to read PNG data!\r\n"); 
		TRACE2("%s : %s \r\n",szSkinFile,szError) ; 
		IS40_CloseSource(hSrc) ;
		return FALSE ; 
	}
	IS40_CloseSource(hSrc) ;
	
	m_hOriginal = DEBUG_NEW BYTE[w*h*4] ; 
	
	memcpy(m_hOriginal,(LPBYTE)m_hOriginalRGB,w*h*4) ; 
		
	HGLOBAL m_hDib = IS40_RGBAToDIB((LPBYTE)m_hOriginalRGB,w,h,w * 4,NULL,0) ; 
	if (m_hDib == NULL) 
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to read DIB section!\r\n")) ; 
		CleanUp() ;
		return FALSE ; 
		
	}
	
	HDC hDC = ::GetDC(NULL) ; 

	m_hObject = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;
	
	if (m_hObject == NULL) 
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to create HBITMAP!\r\n")) ; 
		CleanUp() ;
		::ReleaseDC(NULL,hDC) ; 
		GlobalFree(m_hDib) ; 
		return FALSE ; 
		
	}
	GlobalFree(m_hDib) ; 
	::ReleaseDC(NULL,hDC) ; 

	
	POINT* pData = (POINT*)pHeader ;
	if (pData) 
		m_ptPosition = *pData ; 
	else 
		{m_ptPosition.x = 0; m_ptPosition.y =0;} 

	CRect rctActive ;
	
	UINT rawWidth = w/4 ; 
	if (w % 4 != 0) rawWidth += w %4 ; 

	//zameniti w sa rawwidth  
    	
	BYTE* pMask = DEBUG_NEW BYTE[rawWidth*h*4] ; 
	
	memset(pMask,255,rawWidth*h*4) ;  
	
	BYTE* pCrop = DEBUG_NEW BYTE[rawWidth*h*4] ; 

	//CRect rectCrop(0,0,rawWidth,h) ; 
	CRect rectCrop(0,0,rawWidth,h) ; 
	
	BOOL bSucces = IS40_CropImage((LPBYTE)m_hOriginalRGB,w,h,w*4,pCrop,rawWidth*4,&rectCrop,4) ;  
	
	if (!bSucces)
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to crop image!\r\n")) ; 
		CleanUp() ;
		
		delete [] pMask ; 
		delete [] pCrop ; 
		
		return FALSE ; 
    }
	
	Create1BitMask(pCrop,pMask,rawWidth,h) ; 
		
	if (CreateRectFromRgn(pMask,rctActive,m_ptPosition)) 
	{
		m_rectActive.left = pData->x + rctActive.left ; 
		m_rectActive.top = pData->y + rctActive.top ; 
		m_rectActive.right = m_rectActive.left  + rctActive.Width() ; 
		m_rectActive.bottom = m_rectActive.top + rctActive.Height() ;
	}
	else
	{
		rctActive.SetRectEmpty() ; 
	}
	delete [] pCrop ; 
    delete [] pMask; 
	delete [] pHeader ;

	return TRUE ; 
	
	
}
void CGDIButton::Draw(CDC* dcMemory,UINT nState,BOOL bAlpha) 
{
	CDC dcState ;
		
	BLENDFUNCTION blendPixelFunction= { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
	
	dcState.CreateCompatibleDC(dcMemory) ;  
	CBitmap* pBmpNormalOld = dcState.SelectObject(this) ; 
	
	BITMAP bmpInfo ; 
	GetBitmap(&bmpInfo) ; 
	
	int nWidth =  bmpInfo.bmWidth / 4 ; 
	int nHeight = bmpInfo.bmHeight;

	int xPos,yPos ; 
    	
	switch (nState)
	{
		case NORMAL: xPos=0;yPos=0;break ; 
		case OVER : xPos = nWidth; yPos = 0;break ; 
		case PRESED:xPos = nWidth * 2 ; yPos = 0 ; break ;
		case INACTIVE : xPos = nWidth * 3 ; yPos = 0 ;break ;
			
	}
	
	int x = m_ptPosition.x ; 
	int y = m_ptPosition.y ; 
	
	BOOL bSucces = dcMemory->AlphaBlend(m_ptPosition.x,m_ptPosition.y,nWidth,nHeight,&dcState,
										xPos,yPos,nWidth,nHeight,blendPixelFunction) ; 
			
	dcState.SelectObject(pBmpNormalOld) ; 
		
	dcState.DeleteDC(); 


}
void CGDIButton::Draw(CDC* dcMemory,BOOL bAlpha) 
{
	Draw(dcMemory,m_nState,bAlpha) ; 
}


bool CGDIButton::IsPtInRect (CPoint point) 
{
	if (m_nState == INACTIVE) 
		return false ; 
	else 
		return GDIBitmap::IsPtInRect(point); 
}
bool CGDIButton::IsPtInRgn(CPoint point) 
{
	if (m_nState == INACTIVE) 
		return false ; 
	else 
		return GDIBitmap::IsPtInRgn(point); 
    
}
IMPLEMENT_DYNAMIC(CGDIStatic,CGdiObject) 
BOOL CGDIStatic::ReadPGF(LPCWSTR szSkinFile) 
{
	return GDIBitmap::ReadPGF(szSkinFile) ; 
   	
}

void CGDIStatic::Draw(CDC* dcMemory,CString strText) 
{
	
	GenerateBitmap() ; 

	CFont font;
	CUtils::GetDefaultFont(font); 
	
	CDC dcName ; 
	dcName.CreateCompatibleDC(dcMemory) ;  

	CBitmap* pBmpOld = dcName.SelectObject(this) ;  

	BITMAP bmpInfo ; 
	GetBitmap(&bmpInfo) ; 

	CFont* pOldFont = dcName.SelectObject(&font) ;
	
	CSize szName = dcName.GetTextExtent(strText) ; 
	
	CRect rectText(0,0,bmpInfo.bmWidth,bmpInfo.bmHeight) ; 
	
	dcName.SetBkMode(TRANSPARENT) ; 
	
	dcName.SetTextColor(RGB(157,157,157)) ;
	
	UINT nFormat = DT_CENTER ; 
	
	if (strText.GetLength() > 10 ) 
	{
		strText = strText.Left(10) ; 
		strText += "..." ; 
    }
	dcName.DrawText(strText,&rectText,nFormat) ; 

	 
	BLENDFUNCTION blend = {AC_SRC_OVER,0,255,AC_SRC_ALPHA} ; 


	dcMemory->AlphaBlend(m_ptPosition.x,m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight,&dcName,0,0,bmpInfo.bmWidth,bmpInfo.bmHeight,blend) ;
	
	dcName.SelectObject(pBmpOld) ; 
	dcName.SelectObject(pOldFont) ; 

	dcName.DeleteDC() ;


}
void CGDIStatic::Draw(CDC* dcMemory) 
{
	BLENDFUNCTION blendPixelFunction= { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
	BITMAP bmpInfo ;

	CDC bmpAlpha ; 
	bmpAlpha.CreateCompatibleDC(dcMemory) ; 
	
	CBitmap* pBmpAlphaOld = bmpAlpha.SelectObject(this) ;
	GetBitmap(&bmpInfo); 


	BOOL bSucces = dcMemory->AlphaBlend(m_ptPosition.x,m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight,&bmpAlpha,
									 0,0,bmpInfo.bmWidth,bmpInfo.bmHeight,blendPixelFunction) ; 
	
	bmpAlpha.SelectObject(pBmpAlphaOld) ; 
	bmpAlpha.DeleteDC() ;



}
IMPLEMENT_DYNAMIC(CGDImage,CGdiObject) 

BOOL CGDImage::ReadPGF(LPCWSTR szSkinFile)
{
	return GDIBitmap::ReadPGF(szSkinFile) ; 
		
}

void CGDImage::Draw(CDC* dcMemory) 
{
	BITMAP bmpInfo ;
	CDC bmpDC ; 
	bmpDC.CreateCompatibleDC(dcMemory) ; 
	CBitmap* bmpOld = bmpDC.SelectObject(this) ;  
	GetBitmap(&bmpInfo); 
	BOOL bSucces = dcMemory->BitBlt(m_ptPosition.x,m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight,&bmpDC,0,0,SRCCOPY) ; 
	bmpDC.SelectObject(bmpOld) ; 
	bmpDC.DeleteDC() ;

}
void CGDImage::Draw(CDC* dcMemory,POINT ptPosition) 
{	
	BITMAP bmpInfo ;
	CDC bmpDC ; 
	bmpDC.CreateCompatibleDC(dcMemory) ; 
	CBitmap* bmpOld = bmpDC.SelectObject(this) ;  
	GetBitmap(&bmpInfo); 
	BOOL bSucces = dcMemory->BitBlt(ptPosition.x,ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight,&bmpDC,0,0,SRCCOPY) ; 
	bmpDC.SelectObject(bmpOld) ; 
	bmpDC.DeleteDC() ; 


}

GDIBitmap::GDIBitmap(void):CBitmap()
{
	m_hOriginalRGB = NULL;
	m_hOriginal = NULL ; 
	w=0;
	h=0; 
    
}
void GDIBitmap::CleanUp() 
{
	if (m_hOriginalRGB)
		GlobalFree(m_hOriginalRGB) ; 

	if (m_hOriginal) 
		delete [] m_hOriginal ; 

	m_rgnActive.DeleteObject() ; 
	DeleteObject() ; 

	
}
GDIBitmap::~GDIBitmap(void)
{
	CleanUp() ;
    	
}

void GDIBitmap::LoadBitmapEx(LPCWSTR lpsFileName)
{
	CleanUp() ; 
	
	HISSRC hSrc;
	
	USES_CONVERSION ; 
	
	TCHAR psPath [MAX_PATH] ; 
	CUtils::GetShortPathName(lpsFileName,psPath) ; 

	hSrc = IS40_OpenFileSource(W2A(psPath)) ;

	UINT uType = IS40_GuessFileType(hSrc);

	IS40_Seek(hSrc,0,0); 
	
	m_hOriginalRGB = IS40_ReadImage(hSrc,&w,&h,1,0); 
	
	m_hOriginal = DEBUG_NEW BYTE[w*h*4] ; 
	
	PreMultiplyRGBChannels((LPBYTE)m_hOriginalRGB,w,h); 

	memcpy(m_hOriginal,(LPBYTE)m_hOriginalRGB,w*h*4) ; 
	
	IS40_CloseSource(hSrc) ;

	HGLOBAL m_hDib = IS40_RGBAToDIB((LPBYTE)m_hOriginalRGB,w,h,w * 4,NULL,0) ; 

	HDC hDC = ::GetDC(NULL) ; 

	m_hObject = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;

	GlobalFree(m_hDib) ; 
	
	::ReleaseDC(NULL,hDC) ; 

	BYTE* pMask = DEBUG_NEW BYTE[w*h*4] ; 
	memset(pMask,255,w*h*4) ;  
	Create1BitMask((LPBYTE)m_hOriginalRGB,pMask,w,h) ;

	CRect rctActive ;
	CreateRectFromRgn(pMask,rctActive,m_ptPosition);

	
	delete [] pMask ; 

}

void GDIBitmap::GenerateBitmap() 
{
	DeleteObject() ; 
	if (m_hOriginal) 
	{
		HGLOBAL m_hDib = IS40_RGBAToDIB((LPBYTE)m_hOriginal,w,h,w * 4,NULL,0) ; 
		if (!m_hDib) 
		{
			GlobalFree(m_hDib) ;  
			TRACE("%s:Failed to generate DIB section from RGB buffer!",m_szSkinFile); 
			return ; 
		}
		HDC hDC = ::GetDC(NULL) ; 
		m_hObject = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;	
		if (!m_hObject) 
		{
			GlobalFree(m_hDib) ;  
			::ReleaseDC(NULL,hDC); 
			TRACE("%s:Failed to generate BITMAP from DIB section!",m_szSkinFile); 
			return ; 
		}
		GlobalFree(m_hDib) ;  
		::ReleaseDC(NULL,hDC) ; 
	}
	

}
void GDIBitmap::PreMultiplyRGBChannels(LPBYTE hImg,UINT32& w,UINT32& h)
{
	for (int y=0; y<h;++y)
	{
		for (int x=0; x<w ;++x)
		{
			BYTE* pPixel = hImg + x * 4 + y * w * 4 ;
			pPixel[0]= pPixel[0]*pPixel[3]/255;
			pPixel[1]= pPixel[1]*pPixel[3]/255;
			pPixel[2]= pPixel[2]*pPixel[3]/255;
			pPixel+= 4;
		}
	}
}
BOOL GDIBitmap::ReadPGF(LPCWSTR szSkinFile) 
{
	
	m_szSkinFile = szSkinFile ; 

	HGLOBAL hOriginalRGB;
	RGBQUAD Palette[256];
	USES_CONVERSION ; 
 
	TCHAR psPath [MAX_PATH] ; 
	CUtils::GetShortPathName(szSkinFile,psPath) ; 

	HISSRC hSrc = IS40_OpenFileSource(W2A(psPath)) ;  
	
	IS40_Seek(hSrc, 0, 0) ; 
	
	UINT32 uDataLen = sizeof(POINT) ; 
	
	BYTE* pHeader = DEBUG_NEW BYTE[uDataLen] ; 

	IS40_Read(hSrc,pHeader,uDataLen) ; 

	IS40_Seek(hSrc, uDataLen, 0) ; 

	m_hOriginalRGB = IS40_ReadPNG(hSrc, &w, &h, 32, Palette,0);
	if (m_hOriginalRGB == NULL) 
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to read PNG data!\r\n")) ; 
		IS40_CloseSource(hSrc) ;
		return FALSE ; 
	}
	
	m_hOriginal = DEBUG_NEW BYTE[w*h*4] ; 
	
	memcpy(m_hOriginal,(LPBYTE)m_hOriginalRGB,w*h*4) ; 
	
	IS40_CloseSource(hSrc) ;
	
	HGLOBAL m_hDib = IS40_RGBAToDIB((LPBYTE)m_hOriginalRGB,w,h,w * 4,NULL,0) ; 
	if (m_hDib == NULL) 
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to read DIB section!\r\n")) ; 
		CleanUp() ;
		return FALSE ; 
		
	}

	HDC hDC = ::GetDC(NULL) ; 
	m_hObject = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;
	
	if (m_hObject == NULL) 
	{
		TRACE2("%s : %s \r\n",szSkinFile,_T("Failed to create HBITMAP!\r\n")) ; 
		CleanUp() ;
		::ReleaseDC(NULL,hDC) ; 
		GlobalFree(m_hDib) ; 
		return FALSE ; 
	}
	
	GlobalFree(m_hDib) ; 
	::ReleaseDC(NULL,hDC) ; 
	
	POINT* pData = (POINT*)pHeader ;
	
	if (pData) m_ptPosition = *pData ; 
	else  {m_ptPosition.x = 0; m_ptPosition.y =0; }
		
	CRect rctActive ;

	BYTE* pMask = DEBUG_NEW BYTE[w*h*4] ; 
	
	memset(pMask,255,w*h*4) ;  
	
	Create1BitMask((LPBYTE)m_hOriginalRGB,pMask,w,h) ; 

	
  

	if (CreateRectFromRgn(pMask,rctActive,m_ptPosition)) 
	{
		m_rectActive.left = pData->x + rctActive.left ; 
		m_rectActive.top = pData->y + rctActive.top ; 
		m_rectActive.right = m_rectActive.left  + rctActive.Width() ; 
		m_rectActive.bottom = m_rectActive.top + rctActive.Height() ;
	}
	else
	{
		rctActive.SetRectEmpty() ; 
	
	}
	delete [] pHeader ; 
	delete [] pMask ; 
	
	return TRUE ; 

}


void GDIBitmap::WritePGF(LPCWSTR szSkinFile)
{
	RGBQUAD Palette[256];
	
	USES_CONVERSION ; 
	TCHAR pszOut [MAX_PATH] ;  
	CUtils::GetShortPathName(szSkinFile,pszOut) ; 
	HISDEST hDest = IS40_OpenFileDest(W2A(pszOut),FALSE);
	
	UINT uBytesWrite = 0 ;
	UINT uDataLen = sizeof(POINT) ; 
	
	IS40_Write(hDest,(BYTE*)&m_ptPosition ,uDataLen) ; 
	uBytesWrite = IS40_WritePNG(hDest,(LPBYTE)m_hOriginalRGB ,w,h,w*4, 8, 0, Palette, 6, 0, NULL,0);

	IS40_CloseDest(hDest) ;


}

bool GDIBitmap::IsPtInRect(CPoint point)
{
	if (m_rectActive.PtInRect(point)) 
		return true ; 
	else 
		return false ; 

}
bool GDIBitmap::IsPtInRgn(CPoint point)
{
	
	if (m_rgnActive.PtInRegion(point) )
		return true ; 
	else 
		return false ; 
}

BOOL GDIBitmap::Create1BitMask (BYTE* pImg,BYTE* pMask,UINT w,UINT h) 
{
	for (int y=0; y<h;++y)
	{
		for (int x=0; x<w ;++x)
		{
			BYTE* pPixel = pImg + x * 4 + y * w * 4 ;

			if (pPixel[3] == 255 ) 
				   pMask[0] = pMask[1] = pMask[2] = 0 ; 
			pPixel+= 4;
			pMask +=4 ; 

		}
	}
	return TRUE ;

}
HBITMAP GDIBitmap::Create1BitMask () 
{
	BYTE* pMask = new BYTE[w*h*4] ; 
	memset(pMask,255,w*h*4) ; 

	for (int y=0; y<h;++y)
	{
		for (int x=0; x<w ;++x)
		{
			BYTE* pPixel = (LPBYTE)m_hOriginalRGB + x * 4 + y * w * 4 ;
			if (pPixel[3] == 255 ) 
				   pMask[0] = pMask[1] = pMask[2] = 0 ; 
			pPixel+= 4;
			pMask +=4 ; 

		}
	}
	HGLOBAL m_hDib = IS40_RGBAToDIB(pMask,w,h,w * 4,NULL,0) ;   

	if (m_hDib) 
	{
		HDC hDC = ::GetDC(NULL) ; 
		HBITMAP hBitmap = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;

		if (hBitmap)
		{
			delete [] pMask ; 
			GlobalFree(m_hDib) ; 
			::ReleaseDC(NULL,hDC);   
            return hBitmap ; 	
		}

	}
	return NULL ;


}
BOOL GDIBitmap::CreateRectFromRgn (BYTE* pMask,CRect& rctActive,POINT ptPosition) 
{
	BOOL bSucces =0;
	HGLOBAL m_hDib = NULL ; 
	UINT nWidth = 0 ; 


	if (this->IsKindOf(RUNTIME_CLASS(CGDIButton))) nWidth = w /4 ; 
	else nWidth = w ; 
	
	m_hDib = IS40_RGBAToDIB((LPBYTE)pMask,nWidth,h,nWidth * 4,NULL,0) ; 	
		
	if (m_hDib == NULL) 
	{
		TRACE1("%s:Failed to read DIB section from 1bit mask!\r\n",m_szSkinFile) ; 
		GlobalFree(m_hDib) ; 
		return FALSE ; 		

	}
		
	HDC hDC = ::GetDC(NULL) ; 

	HBITMAP hBitmap = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;
	if(hBitmap == NULL)
	{
		
		TRACE1("%s:Failed to create 1bit bitmap mask!\r\n",m_szSkinFile) ; 
		GlobalFree(m_hDib) ; 
		::ReleaseDC(NULL,hDC);  
		return FALSE ; 
		
	}

	GlobalFree(m_hDib) ; 
	::ReleaseDC(NULL,hDC) ; 

    
	HRGN hRgn =  CUtils::BitmapToRegion(hBitmap,RGB(255,255,255),RGB(0,0,0)) ;

	if (hRgn)
	{
		m_rgnActive.Attach(hRgn) ; 
		
		int nRetVal = m_rgnActive.GetRgnBox(rctActive);
		
		if (nRetVal == SIMPLEREGION)
		{
			//m_rgnActive.OffsetRgn(ptPosition) ; 
			bSucces =  TRUE ; 
		}
		else 
		{
			//try complex region 
			if (nRetVal == COMPLEXREGION) 
			{
				//m_rgnActive.OffsetRgn(ptPosition) ; 
				bSucces = TRUE  ;
			}
			if (nRetVal == NULLREGION)
			{
											
				if (this->IsKindOf(RUNTIME_CLASS(CGDIButton))) nWidth = w /4 ; 
				else nWidth = w ; 
				
				m_rgnActive.Detach() ; 
				m_rgnActive.CreateRectRgn(0,0,nWidth,h) ; 
		
				rctActive.right = nWidth ; 
				rctActive.bottom = h ; 
				
				bSucces = TRUE;
			}
		}
	
	}
	else 
	{
		bSucces = FALSE ; 
		TRACE("%s Failed to create region from 1 bit mask\r\n",m_szSkinFile); 
	}
	//::DeleteObject(hRgn); 
	::DeleteObject(hBitmap); 

	return bSucces ; 
}
void GDIBitmap::GetActiveRect(CRect& rctActive) 
{
	BYTE* pMask = DEBUG_NEW BYTE[w*h*4] ; 
	memset(pMask,255,w*h*4) ; 
	
	Create1BitMask((LPBYTE)m_hOriginalRGB,pMask,w,h) ; 
	
	if (!CreateRectFromRgn(pMask,rctActive,m_ptPosition)) 
	{
		rctActive.SetRectEmpty() ; 
	}
	
	delete [] pMask; 
}

HRGN GDIBitmap::GetWindowRegion() 
{
/*	CRgn* retRgn = new CRgn()  ;
	retRgn->CreateRectRgn(0,0,0,0) ; 
	retRgn->CopyRgn(&m_rgnActive) ; 
	return *retRgn */; 
	return m_rgnActive ; 
	   
}

void GDIBitmap::Draw(CDC* dcMemory,UINT nState,BOOL bAlpha) 
{
	CDC dcState ;
	BLENDFUNCTION blendPixelFunction= { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
	dcState.CreateCompatibleDC(dcMemory) ;  
	
	CBitmap* pBmpNormalOld = dcState.SelectObject(this) ; 
	BITMAP bmpInfo ; 
	GetBitmap(&bmpInfo) ; 
	int nWidth =  bmpInfo.bmWidth ; // / 4 ; 
	int nHeight = bmpInfo.bmHeight ;// / 4; 

	int xPos,yPos ; 
    	
	switch (nState)
	{
		case NORMAL: xPos=0;yPos=0;break ; 
		case OVER : xPos = nWidth; yPos = nHeight;break ; 
		case PRESED:xPos = nWidth * 2 ; yPos = nHeight * 2 ; break ;
		case INACTIVE : xPos = nWidth * 3 ; yPos = nHeight * 3 ;break ;
			
	}
	
	BOOL bSucces ; 

	if (bAlpha) 
	{
		bSucces = dcMemory->AlphaBlend(m_ptPosition.x,m_ptPosition.y,nWidth,nHeight,&dcState,
										xPos,yPos,nWidth,nHeight,blendPixelFunction) ; 
	}
	else 
	{
		bSucces = dcMemory->BitBlt(m_ptPosition.x,m_ptPosition.y,nWidth,nHeight,&dcState,
										xPos,yPos,SRCCOPY) ; 
	}
	dcState.SelectObject(pBmpNormalOld) ; 
	dcState.DeleteDC(); 

}




