#pragma once
#include "Utils.h" 
#include "FileManager.h" 

#define NORMAL 0 
#define OVER 1 
#define PRESED 2 
#define INACTIVE 3 


class GDIBitmap : public CBitmap 
{
	
public:
	GDIBitmap(void);
	~GDIBitmap(void);
	void LoadBitmapEx(LPCWSTR lpsFileName) ; 
	void PreMultiplyRGBChannels(LPBYTE hImg,UINT32& w,UINT32& h);  
	void GenerateBitmap() ;
	void CleanUp(); 
	BOOL ReadPGF(LPCWSTR szSkinFile) ; 
	void WritePGF(LPCWSTR szSkinFile); 
	
	bool IsPtInRect(CPoint point) ; 
	bool IsPtInRgn(CPoint point);

	void OnNormal(CDC* dcMemory) ; 
	void OnMouseOver(CDC* dcMemory); 
	void OnMouseDown(CDC* dcMemory) ;  
	void OnInactive(CDC* dcMemory) ; 
	void Draw(CDC* dcMemory,UINT nState,BOOL bAlpha = TRUE) ; 
	BOOL CreateRectFromRgn (BYTE* pMask,CRect& rctActive,POINT ptPosition) ;
	void GetActiveRect(CRect& rctActive) ;
	
	HRGN GetWindowRegion() ; 
	
	HBITMAP Create1BitMask () ; 
	
	POINT m_ptPosition ;
	CRect m_rectActive ; 
	CRgn m_rgnActive ; 
	HRGN m_hRgn ; 
	HBITMAP m_hBmpMask ; 

    
protected : 
	BOOL Create1BitMask (BYTE* pImg,BYTE* pMask,UINT w,UINT h) ; 

public: 
	HGLOBAL m_hOriginalRGB ; 
	CString m_szSkinFile  ; 
	LPBYTE m_hOriginal ; 
	HBITMAP m_hBitmap ; 
	UINT w,h ; 
};

class CGDIButton : public GDIBitmap 
{
	DECLARE_DYNAMIC(CGDIButton) 

public : 
	CGDIButton():GDIBitmap() {m_nState = NORMAL;}
	~CGDIButton() {} 
	BOOL ReadPGF(LPCWSTR szSkinFile) ; 
	void Draw(CDC* dcMemory,UINT nState,BOOL bAlpha =TRUE) ; 
	void Draw(CDC* dcMemory,BOOL bAlpha=TRUE) ; 
	void SetState(UINT nState) { m_nState = nState ;} 
	UINT GetState() { return m_nState ; }  
	bool IsPtInRect (CPoint point) ; 
	bool IsPtInRgn (CPoint point) ; 


private : 
	UINT m_nState ;
	UINT m_rawWidth ; 


}; 
class CGDIStatic : public GDIBitmap
{
	DECLARE_DYNAMIC(CGDIStatic) 
public : 
	CGDIStatic():GDIBitmap() {}  
	~CGDIStatic() {}  
	BOOL ReadPGF(LPCWSTR szSkinFile) ; 
	void Draw(CDC* dcMemory,CString strText) ;
	void Draw(CDC* dcMemory) ; 
   

};
class CGDImage : public GDIBitmap 
{
	DECLARE_DYNAMIC(CGDImage) 
public:
	CGDImage():GDIBitmap() {}
	~CGDImage() {} 
	BOOL ReadPGF(LPCWSTR szSkinFile) ; 
	void Draw(CDC* dcMemory) ; 
	void Draw(CDC* dcMemory,POINT ptPosition) ; 

};
class CGDIDialog : public GDIBitmap
{
	DECLARE_DYNAMIC(CGDIDialog) 

	CGDIDialog():GDIBitmap() {} 
	~CGDIDialog() {}
	BOOL ReadPGF(LPCWSTR szSkinFile) ; 
	void Draw(CDC* dcMemory,BOOL bAlpha = TRUE) ; 
	

};
