// client\SkinAnimate.cpp : implementation file
//

#include "stdafx.h"
#include "SkinAnimate.h"


// CSkinAnimate
BEGIN_MESSAGE_MAP(CSkinAnimate, CStatic)
	ON_WM_TIMER() 
END_MESSAGE_MAP()


IMPLEMENT_DYNAMIC(CSkinAnimate, CStatic)
CSkinAnimate::CSkinAnimate()
{
	m_nFrame = 0 ;
	m_bStop = TRUE ; 
	
}
BOOL CSkinAnimate::Create(CWnd* pParent,CString strFile,UINT nID)
{

	m_bmpFrames.ReadPGF(strFile) ; 
	BITMAP bmpInfo ; 
	m_bmpFrames.GetBitmap(&bmpInfo) ; 
	
	m_nFrameWidth = bmpInfo.bmWidth / FRAME_COUNT  ; 
	m_nFrameHeight = bmpInfo.bmHeight ;

	CRect rectWnd(m_bmpFrames.m_ptPosition.x,m_bmpFrames.m_ptPosition.y,
		  m_bmpFrames.m_ptPosition.x + m_nFrameWidth, 
		  m_bmpFrames.m_ptPosition.y + m_nFrameHeight) ;	

	BOOL bCreate = CStatic::Create(_T(""),WS_CHILD | WS_VISIBLE | SS_OWNERDRAW,rectWnd,pParent,nID) ;  

	m_nFrame = 0 ;
	m_bStop = TRUE ; 	
	return bCreate ; 
}
CSkinAnimate::~CSkinAnimate()
{

}

void CSkinAnimate::Play () 
{
	CWnd* parent = GetParent() ; 
	::SetTimer(parent->m_hWnd,PLAY_ANIMATION,FRAME_PER_SEC,NULL) ; 
	DWORD dwError = GetLastError() ; 

}
void CSkinAnimate::Stop() 
{
	CWnd* parent = GetParent() ; 
	::KillTimer(parent->m_hWnd,PLAY_ANIMATION) ; 
}
void CSkinAnimate::StepIt() 
{
	if (m_nFrame == FRAME_COUNT -1) 
		m_nFrame = 0 ; 
	else 
		m_nFrame++ ;
	
}

void CSkinAnimate::OnTimer(UINT_PTR nIDEvent) 
{
	if (!m_bStop) 
	{
		if (m_nFrame == FRAME_COUNT) 
			m_nFrame = 0 ; 
			
		CPaintDC dc(this) ; 
		CDC dcMemory ; 
		dc.CreateCompatibleDC(&dcMemory) ; 

		HBITMAP bmpOld = (HBITMAP)dcMemory.SelectObject(&m_bmpFrames) ; 
		int xPos = m_nFrame * m_nFrameWidth ; 
		INT yPos = 0 ; 
		
		dc.BitBlt(m_ptPosition.x,m_ptPosition.y,m_nFrameWidth,m_nFrameHeight,&dcMemory,xPos,yPos,SRCCOPY) ; 
        dcMemory.SelectObject(bmpOld); 
		dcMemory.DeleteDC() ; 
		
		m_nFrame++ ; 
	}
	else 
	{
		m_nFrame = 0 ; 

	}

	CStatic::OnTimer(nIDEvent) ; 
}

void CSkinAnimate::Draw(CDC* dcMemory) 
{
	CDC dc ; 
	dc.CreateCompatibleDC(dcMemory) ; 
	HBITMAP bmpOld = (HBITMAP)dc.SelectObject(&m_bmpFrames) ; 
	int xPos = m_nFrame * m_nFrameWidth ; 
	INT yPos = 0 ; 
	
	dcMemory->BitBlt(m_ptPosition.x,m_ptPosition.y,m_nFrameWidth,m_nFrameHeight,&dc,xPos,yPos,SRCCOPY) ; 
    dc.SelectObject(bmpOld); 
	dc.DeleteDC() ; 

}

void CSkinAnimate::DrawItem(LPDRAWITEMSTRUCT lpDrawStruct) 
{
			
	CDC* dc = CDC::FromHandle(lpDrawStruct->hDC) ; 
	CDC dcMemory ; 
	dcMemory.CreateCompatibleDC(dc) ; 

	HBITMAP bmpOld = (HBITMAP)dcMemory.SelectObject(&m_bmpFrames) ; 
	int xPos = m_nFrame * m_nFrameWidth ; 
	int yPos = 0 ; 
	
	dc->BitBlt(0,0,m_nFrameWidth,m_nFrameHeight,&dcMemory,xPos,yPos,SRCCOPY) ; 

    dcMemory.SelectObject(bmpOld); 
	dcMemory.DeleteDC() ;  
	 
}



// CSkinAnimate message handlers

