// client\SkinCheckBox.cpp : implementation file
//

#include "stdafx.h"
#include "SkinCheckBox.h"


// CSkinCheckBox

IMPLEMENT_DYNAMIC(CSkinCheckBox, CButton)
CSkinCheckBox::CSkinCheckBox()
{
	m_bDown = FALSE ; 
	m_bUp = FALSE ;
	m_bOver = FALSE ;

}

CSkinCheckBox::~CSkinCheckBox()
{
}

BOOL CSkinCheckBox::Create(CString strFile,CWnd* pParent,UINT nID) 
{
	m_pWndParent =  pParent ; 
	m_pGdiBtn.ReadPGF(strFile) ; 
		
	LONG dwStyleEx = GetWindowLong(pParent->m_hWnd,GWL_EXSTYLE) ; 
	DWORD dwStyle = 0 ; 
	dwStyle =  WS_VISIBLE | WS_CHILD | BS_NOTIFY;
	m_bLayered =  dwStyleEx & WS_EX_LAYERED ?  TRUE : FALSE  ; 

	BITMAP bmpInfo ; 
	m_pGdiBtn.GetBitmap(&bmpInfo) ;
	CRect rectWnd (m_pGdiBtn.m_ptPosition.x,m_pGdiBtn.m_ptPosition.y,
				   m_pGdiBtn.m_ptPosition.x + bmpInfo.bmWidth/4,
				   m_pGdiBtn.m_ptPosition.y + bmpInfo.bmHeight); 
	
	BOOL bCreate =  CButton::Create(NULL,dwStyle,rectWnd,pParent,nID) ; 


	HRGN hRgnWindow = m_pGdiBtn.GetWindowRegion() ;
	int nRet = SetWindowRgn(hRgnWindow,TRUE) ; 
	
	SetTimer(nID,100,NULL) ; 
	return bCreate ;

}
BOOL CSkinCheckBox::Create(CString strFile,CWnd* pParent,UINT nID,CPoint point) 
{
	m_pWndParent =  pParent ; 
	
	m_pGdiBtn.m_ptPosition.x = 0 ; 
	m_pGdiBtn.m_ptPosition.y = 0 ; 
	
	m_pGdiBtn.LoadBitmapEx(strFile) ; 
	
	LONG dwStyleEx = GetWindowLong(pParent->m_hWnd,GWL_EXSTYLE) ; 
	DWORD dwStyle = 0 ; 
	dwStyle = dwStyleEx & WS_EX_LAYERED ?  WS_VISIBLE | BS_NOTIFY : WS_CHILD | WS_VISIBLE | BS_NOTIFY ; 
	m_bLayered =  dwStyleEx & WS_EX_LAYERED ?  TRUE : FALSE  ; 

	BITMAP bmpInfo ; 
	m_pGdiBtn.GetBitmap(&bmpInfo) ;
	CRect rectWnd (m_pGdiBtn.m_ptPosition.x,m_pGdiBtn.m_ptPosition.y,
				   m_pGdiBtn.m_ptPosition.x + bmpInfo.bmWidth/4,
				   m_pGdiBtn.m_ptPosition.y + bmpInfo.bmHeight); 
	
	BOOL bCreate =  CButton::Create(NULL,dwStyle,rectWnd,pParent,nID) ; 

	
	HRGN hRgnWindow = m_pGdiBtn.GetWindowRegion() ;
	int nRet = SetWindowRgn(hRgnWindow,TRUE) ;  
	
	SetTimer(nID,100,NULL) ; 
	
	return bCreate ;
}
BOOL CSkinCheckBox::Create(UINT nResID,CWnd* pParent,UINT nID,CPoint point) 
{
	m_pWndParent =  pParent ; 
	
	m_pGdiBtn.m_ptPosition.x = point.x; 
	m_pGdiBtn.m_ptPosition.y = point.y ; 


	m_pGdiBtn.LoadBitmap(nResID) ; 

	LONG dwStyleEx = GetWindowLong(pParent->m_hWnd,GWL_EXSTYLE) ; 
	DWORD dwStyle = 0 ; 
	dwStyle =  WS_VISIBLE | WS_CHILD | BS_NOTIFY;
	m_bLayered =  dwStyleEx & WS_EX_LAYERED ?  TRUE : FALSE  ; 

	BITMAP bmpInfo ; 
	m_pGdiBtn.GetBitmap(&bmpInfo) ;
	CRect rectWnd (m_pGdiBtn.m_ptPosition.x,m_pGdiBtn.m_ptPosition.y,
				   m_pGdiBtn.m_ptPosition.x + bmpInfo.bmWidth/4,
				   m_pGdiBtn.m_ptPosition.y + bmpInfo.bmHeight); 
	
	BOOL bCreate =  CButton::Create(NULL,dwStyle,rectWnd,pParent,nID) ; 


	m_pGdiBtn.m_rgnActive.CreateRectRgn(0,0,rectWnd.Width(),rectWnd.Height()) ; 
	
	HRGN hRgnWindow = m_pGdiBtn.GetWindowRegion() ;
	CRect rect ; 
	int nRetBox = ::GetRgnBox(hRgnWindow,&rect);
	int nRet = SetWindowRgn(hRgnWindow,TRUE) ; 

	SetTimer(nID,100,NULL) ; 
	return bCreate ;


}


void CSkinCheckBox::PreSubclassWindow()
{
	if (!m_bLayered) 
		ModifyStyle(0,BS_OWNERDRAW) ;
	CButton::PreSubclassWindow() ; 

}

void CSkinCheckBox::OnMouseMove(UINT nFlags,CPoint point) 
{
	if (m_pGdiBtn.GetState() != INACTIVE)
	{
	
		if (m_pGdiBtn.GetState() == NORMAL) 
			SetTimer(GetDlgCtrlID(),100,NULL) ; 
			
		m_pGdiBtn.SetState(OVER) ;  

		if (m_bDown) 
			m_pGdiBtn.SetState(PRESED)  ; 
		
		
	}
	Paint() ; 

	CButton::OnMouseMove(nFlags, point);
}
void CSkinCheckBox::OnLButtonDown(UINT nFlags,CPoint point) 
{
	if (m_pGdiBtn.GetState() != INACTIVE) 
	{
		SetCapture() ; 
		m_pGdiBtn.SetState(PRESED) ;
		Paint() ;  

		m_bDown = TRUE ; 
		m_bUp = FALSE ; 
	}
    
	CButton::OnLButtonDown(nFlags, point);
}
LRESULT CSkinCheckBox::WindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam) 
{
	LRESULT lResult = 0;
	if (!OnWndMsg(uMsg, wParam, lParam, &lResult))
		lResult = DefWindowProc(uMsg, wParam, lParam);
	return lResult;
	//return CButton::WindowProc(uMsg,wParam,lParam)  ;
}
void CSkinCheckBox::Paint() 
{
	if (!m_bLayered) 
		Invalidate(FALSE) ; 
	else
		::SendMessage(m_pWndParent->m_hWnd,WM_CSPAINT,NULL,NULL) ; 
	
}
void CSkinCheckBox::SetState(UINT nState) 
{
	m_pGdiBtn.SetState(nState) ; 
	if (nState == INACTIVE) 
		EnableWindow(FALSE) ; 
	else 
		EnableWindow(TRUE) ; 

}
void CSkinCheckBox::OnLButtonUp(UINT nFlags,CPoint point) 
{
	if (m_pGdiBtn.GetState() != INACTIVE && m_bDown) 
	{
		m_bUp = TRUE ; 
		m_bDown = FALSE ; 

		HRGN hRgn = CreateRectRgn(0,0,0,0); 
		GetWindowRgn(hRgn) ; 
		
		if (PtInRegion(hRgn,point.x,point.y))
		{
			int nCtrlID = GetDlgCtrlID() ; 
			::SendMessage(m_pWndParent->m_hWnd,WM_COMMAND,
						MAKEWPARAM(nCtrlID,BN_CLICKED),(LPARAM)m_hWnd);
		}
		ReleaseCapture() ;
	}
	
	Paint() ;
	
	CButton::OnLButtonUp(nFlags, point);
}
void CSkinCheckBox::OnTimer(UINT_PTR nIDEvent) 
{
	CPoint p (GetMessagePos()) ;
	GetCursorPos(&p) ; 
	ScreenToClient(&p) ; 
	
	HRGN hRgn = CreateRectRgn(0,0,0,0) ; 
	GetWindowRgn(hRgn) ; 

	UINT nState = m_pGdiBtn.GetState() ;

		 
	if (!PtInRegion(hRgn,p.x,p.y) )
	{
		m_bDown = FALSE ; 
		m_bUp = FALSE ; 
		KillTimer(nIDEvent) ; 
		if (nState != INACTIVE)
		{
			m_pGdiBtn.SetState(NORMAL) ; 
			Paint() ; 
		}
	}
	else 
	{	
		//SetTimer(GetDlgCtrlID(),100,NULL) ;
	
	}
	DeleteObject(hRgn) ; 
	CButton::OnTimer(nIDEvent);
}
void CSkinCheckBox::DrawItem(LPDRAWITEMSTRUCT lpDrawStruct) 
{
	BITMAP bmpInfo ;
	m_pGdiBtn.GetBitmap(&bmpInfo) ; 

	int nWidth =  bmpInfo.bmWidth / 4 ; 
	int nHeight = bmpInfo.bmHeight ;// / 4; 

	CDC* pDC = CDC::FromHandle(lpDrawStruct->hDC) ; 
	CDC memDC ; 
	memDC.CreateCompatibleDC(pDC) ; 
	
	HBITMAP hBmpOld= (HBITMAP)memDC.SelectObject(m_pGdiBtn) ; 
	int xPos,yPos ; 
   	
	switch (m_pGdiBtn.GetState())
	{
		case NORMAL: xPos=0;yPos=0;break ; 
		case OVER : xPos = nWidth; yPos = 0;break ; 
		case PRESED:xPos = nWidth * 2 ; yPos = 0 ; break ;
		case INACTIVE : xPos = nWidth * 3 ; yPos = 0;break ;
			
	}
	pDC->BitBlt(lpDrawStruct->rcItem.left,lpDrawStruct->rcItem.top,nWidth,nHeight,&memDC,xPos,yPos,SRCCOPY) ; 
    
	memDC.DeleteDC(); 
}

void CSkinCheckBox::Draw(CDC* dcMemory) 
{
	ASSERT(m_pGdiBtn.m_hObject != NULL) ; 
    
	BOOL bAlpha = TRUE ; 
	if (!m_bLayered)
		bAlpha = FALSE ; 

	UINT nState = m_pGdiBtn.GetState() ; 
	m_pGdiBtn.Draw(dcMemory,nState,bAlpha) ;

}


BEGIN_MESSAGE_MAP(CSkinCheckBox, CButton)
END_MESSAGE_MAP()



// CSkinCheckBox message handlers

