// SkinComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "SkinComboBox.h"

static WNDPROC m_pWndProc = 0;




// CSkinComboBox

IMPLEMENT_DYNAMIC(CSkinComboBox, CComboBox)
CSkinComboBox::CSkinComboBox()
{
 m_clrBk = 0 ; 
 m_bmpButton = NULL ;
}

CSkinComboBox::~CSkinComboBox()
{

}

BOOL CSkinComboBox::Create(CWnd* pParent,CRect& rect,UINT nID) 
{
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST |  CBS_OWNERDRAWVARIABLE  ; 
	return CComboBox::Create(dwStyle,rect,pParent,nID); 
	
   
}
void CSkinComboBox::AddItem(int nIndex,CString strText,CBitmap* bmpItem,CFont* fontText,COLORREF clrText,COLORREF clrBkg)
{
	CBItemData *cbData = new CBItemData() ; 
	
	cbData->bmpItem = bmpItem ; 
	cbData->strText = strText ; 
	cbData->m_clrBkg = clrBkg ; 
	cbData->m_clrText = clrText ; 
	cbData->m_fontText = fontText ; 
	m_aoItems.AddTail(cbData) ; 
	InsertString(nIndex,cbData->strText) ; 
	
	DWORD dwError = GetLastError() ; 
	ASSERT(dwError == FALSE) ; 
	
}

void CSkinComboBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	ASSERT(lpDrawItemStruct->CtlType == ODT_COMBOBOX);
	
	CBItemData* cbData ; 
	int nItem = lpDrawItemStruct->itemID ; 
    
   CDC dc;
   CFont * pOldFont = NULL ; 
   CBitmap* pBmpOld = NULL ;  
   dc.Attach(lpDrawItemStruct->hDC);

	if (nItem != -1) 
	{
		cbData = GetItemData(nItem) ; 
	}
	else 
	{
		int nSel = CComboBox::GetCurSel(); 
		cbData = GetItemData(0) ; 
	}
	    
  LPCTSTR lpszText = cbData->strText ;
  ASSERT(lpszText != NULL);

   
  if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
      (lpDrawItemStruct->itemState  & ODS_SELECTED))
   {
     
	  dc.FillSolidRect(&lpDrawItemStruct->rcItem, cbData->m_clrBkg);
	  CBrush brush ;
	  brush.CreateSolidBrush(RGB(0,0,0)) ; 
	  FrameRect(dc.m_hDC,&lpDrawItemStruct->rcItem,brush) ; 
	  TRACE(_T("Selected \r\n"))  ; 
      
   }
 
   else
   {
	   dc.FillSolidRect(&lpDrawItemStruct->rcItem, cbData->m_clrBkg);
	     TRACE(_T("UnSelected \r\n"))  ; 
   }

	  
	  if (cbData->bmpItem != NULL)
	  {
			CDC dcMem ; 
			dcMem.CreateCompatibleDC(&dc) ; 
			
			BITMAP bmpInfo ; 
			cbData->bmpItem->GetBitmap(&bmpInfo) ; 
			pBmpOld = dcMem.SelectObject(cbData->bmpItem) ;  
		
			dc.BitBlt(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top,bmpInfo.bmWidth,bmpInfo.bmHeight,&dcMem,
					   0,0,SRCCOPY); 

			dcMem.SelectObject(pBmpOld) ;  

	  
	   }
	   
	  if (cbData->m_fontText != NULL) 
	   {
		  pOldFont = dc.SelectObject(cbData->m_fontText) ;
		  dc.SetTextColor(cbData->m_clrText) ; 
		  if (cbData->bmpItem != NULL) 
		  {
			  CRect rectItem ;
			  rectItem = lpDrawItemStruct->rcItem ; 
			  BITMAP bmpInfo ; 
			  cbData->bmpItem->GetBitmap(&bmpInfo) ; 
			  rectItem.left += bmpInfo.bmWidth + 5 ; 
			  dc.DrawText(lpszText,wcslen(lpszText),&rectItem,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
		  }
		  else 
		  {
			  dc.DrawText(lpszText,wcslen(lpszText),&lpDrawItemStruct->rcItem,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
		  }
	   }
	  else 
	  {
		  dc.SetTextColor(cbData->m_clrText) ;  
		  if (cbData->bmpItem != NULL) 
		  {
			  CRect rectItem ;
			  rectItem = lpDrawItemStruct->rcItem ; 
			  BITMAP bmpInfo ; 
			  cbData->bmpItem->GetBitmap(&bmpInfo) ; 
			  rectItem.left += bmpInfo.bmWidth + 5 ; 
			  dc.DrawText(lpszText,wcslen(lpszText),&rectItem,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
		  }
		   else 
		   {
				dc.DrawText(lpszText,wcslen(lpszText),&lpDrawItemStruct->rcItem,DT_LEFT | DT_SINGLELINE| DT_VCENTER); 
		   }
	  }

	
  if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
      (lpDrawItemStruct->itemState  & ODS_SELECTED))
   {
	  CBrush brush ;
	  brush.CreateSolidBrush(RGB(0,0,0)) ; 
	  FrameRect(dc.m_hDC,&lpDrawItemStruct->rcItem,brush) ; 
     
   }
   if (pOldFont) dc.SelectObject(pOldFont) ; 
     
   
   dc.Detach();

}


void CSkinComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	
	int nID = lpMeasureItemStruct->itemID;
	if (nID != -1  ) 
	{
		CBItemData* cbData = GetItemData(nID) ; 
		CSize sz = MeasureItemSize(cbData) ; 
	
		lpMeasureItemStruct->itemHeight = sz.cy ; 
		lpMeasureItemStruct->itemWidth  = sz.cx ; 
		
	}

}
CSize CSkinComboBox::MeasureItemSize (CBItemData* cbData )  
{
	int nWidth = 0  ,nHeight = 0 ;  
	CString strText = cbData->strText ; 
	CBitmap* pBmp = cbData->bmpItem ; 
	CFont* pFont = cbData->m_fontText ; 
	COLORREF clrBkg  = cbData->m_clrBkg ;  
	COLORREF clrText = cbData->m_clrText ; 


	CDC * pDC = GetDC() ; 
	CDC memDC ; 
	CFont* oldFont ; 
	memDC.CreateCompatibleDC(pDC) ; 

	if (cbData->m_fontText != NULL) 
	{
		oldFont = memDC.SelectObject(pFont) ;  
		CSize szText = memDC.GetTextExtent(strText) ;  
		
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

		BITMAP bmpInfo ;
		if (pBmp) 
		{		
			pBmp->GetBitmap(&bmpInfo) ; 
			nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
			if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 
			
		}	
		

	}
	else if (pBmp) 
	{
		BITMAP bmpInfo ; 
		pBmp->GetBitmap(&bmpInfo) ; 
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
		if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 

	}
	else 
	{
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

	}

	if (cbData->m_fontText != NULL)
	{
		memDC.SelectObject(oldFont) ;
	}
	
	memDC.DeleteDC() ; 
	ReleaseDC(pDC) ;  

	return CSize(nWidth,nHeight) ; 

}
CSkinComboBox::CBItemData* CSkinComboBox::GetItemData(int index)  
{
	int counter = 0 ; 
	CBItemDataPtr cbData  = NULL; 
	POSITION ps = m_aoItems.GetHeadPosition() ; 

	while (ps)
	{
		cbData = m_aoItems.GetAt(ps) ; 
		if (counter == index) 
			break ; 
		m_aoItems.GetNext(ps); 
		counter++; 
	}
	
	return cbData ; 

}
void CSkinComboBox::DrawItem (CDC* pDC) 
{
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(&rectWindow);

	rectWindow.DeflateRect(1,1,21,1) ;
    	
	int index = GetCurSel() ; 
	if (index == -1) 
		index = 0 ; 

	CBItemData* cbData = GetItemData(index) ;

	CBitmap* bmpItem = cbData->bmpItem ; 
	COLORREF clrBkg = cbData->m_clrBkg ; 
	COLORREF clrText = cbData->m_clrText ; 
	CFont* font = cbData->m_fontText ; 
	CFont* pOldFont = NULL ; 

	CString strText = cbData->strText ; 
	BITMAP bmpInfo ;


	CBrush br(clrBkg) ; 
	pDC->FillRect(&rectWindow,&br) ; 
    
	if (bmpItem)
	{
		CDC dcMem ; 
		dcMem.CreateCompatibleDC(pDC) ; 
		
		bmpItem->GetBitmap(&bmpInfo) ; 
		HBITMAP pBmpOld = (HBITMAP)dcMem.SelectObject(bmpItem) ;  

		pDC->BitBlt(rectWindow.left,rectWindow.top,bmpInfo.bmWidth,bmpInfo.bmHeight,&dcMem,
					0,0,SRCCOPY); 

		dcMem.SelectObject(pBmpOld) ;  
		dcMem.DeleteDC() ; 
	}

	if (!strText.IsEmpty())
	{
		if (font) 
			pOldFont = pDC->SelectObject(font) ; 
		else
		{
			font = GetFont(); 
			pDC->SelectObject(font) ; 
		}
		
		pDC->SetBkMode(TRANSPARENT); 
		pDC->SetTextColor(clrText) ;  
		if (bmpItem) 
		{	
			rectWindow.left += bmpInfo.bmWidth + 5 ; 
		}
		pDC->DrawText(strText,&rectWindow,DT_LEFT | DT_SINGLELINE |  DT_VCENTER ) ; 


	}
	if (pOldFont) 
		pDC->SelectObject(pOldFont);  

}

 void CSkinComboBox::OnPaint() 
 {
	
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(&rectWindow);

	CPaintDC dc(this) ; 
	if (m_clrBk != 0 )
	{
	
		m_rcClientArea.CopyRect(&rectWindow) ; 
		m_rcClientArea.DeflateRect(1,1,20,1) ;
			
		CRgn rgnWnd ; 
		rgnWnd.CreateRectRgn(rectWindow.left,rectWindow.top,rectWindow.right,rectWindow.bottom) ; 
		
		CRgn rgnClient ; 
		rgnClient.CreateRectRgn(m_rcClientArea.left ,m_rcClientArea.top,m_rcClientArea.right,m_rcClientArea.bottom) ; 

		CRgn rgnDiff ; 
		rgnDiff.CreateRectRgn(0,0,0,0); 

		rgnDiff.CombineRgn(&rgnWnd,&rgnClient,RGN_DIFF) ; 
		CRect rect ; 
		int nResult = rgnDiff.GetRgnBox(&rect) ; 

		ASSERT(nResult != NULLREGION) ;
		
		CBrush br(m_clrBk); 
		dc.FillRgn(&rgnDiff,&br) ; 
		rgnClient.DeleteObject() ; 
		rgnWnd.DeleteObject() ; 
		rgnDiff.DeleteObject() ; 
	}
	if (m_bmpButton != NULL) 
	{
		CDC memDC ; 
		memDC.CreateCompatibleDC(&dc) ; 
		CBitmap* bmpOld = memDC.SelectObject(m_bmpButton) ; 
		BITMAP bmpInfo ; 
		m_bmpButton->GetBitmap(&bmpInfo) ; 

		CRect rectButton ; 
		rectButton.left = rectWindow.right - 20 ; 
		rectButton.top = rectWindow.top + 2 ; 
		rectButton.right = rectWindow.right  - 2; 
		rectButton.bottom = rectWindow.bottom ; 

		dc.BitBlt(rectButton.left,rectButton.top,20,20,&memDC,0,0,SRCCOPY) ; 
		memDC.SelectObject(bmpOld) ; 
		memDC.DeleteDC() ; 

	}

	DrawItem(&dc) ; 
    	

 }
 LRESULT CSkinComboBox::OnCtlColorListBox(WPARAM wParam, LPARAM lParam) 
{
	return DefWindowProc(WM_CTLCOLORLISTBOX, wParam, lParam);
}
 HBRUSH CSkinComboBox::OnCtlColor(CDC* pDC,CWnd* pWnd,UINT nCtlColor) 
 {
	 return GetSysColorBrush(BLACK_BRUSH) ; 
 }
 void CSkinComboBox::OnLButtonDown(UINT nFlags,CPoint point) 
 {
	
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(&rectWindow);

	CRect rectButton ; 
	rectButton.left = rectWindow.right - 20 ; 
	rectButton.top = rectWindow.top + 1 ; 
	rectButton.right = rectWindow.right  - 1; 
	rectButton.bottom = rectWindow.bottom ; 
	if (rectButton.PtInRect(point) )
	{
		//change the state of button 
		InvalidateRect(&rectButton) ; 
	}
	CComboBox::OnLButtonDown(nFlags,point) ; 

 }
 void CSkinComboBox::OnLButtonUp(UINT nFlags,CPoint point) 
 {	
	 
	
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(&rectWindow);

	CRect rectButton ; 
	rectButton.left = rectWindow.right - 20 ; 
	rectButton.top = rectWindow.top + 1 ; 
	rectButton.right = rectWindow.right  - 1; 
	rectButton.bottom = rectWindow.bottom   ; 
	if (rectButton.PtInRect(point)) 
	{
		//change the state of button 
		InvalidateRect(&rectButton) ; 
	}
	CComboBox::OnLButtonUp(nFlags,point) ;

 }

BEGIN_MESSAGE_MAP(CSkinComboBox, CComboBox)
	ON_WM_PAINT() 
	ON_MESSAGE(WM_CTLCOLORLISTBOX, OnCtlColorListBox)
	ON_WM_LBUTTONDOWN() 
	ON_WM_LBUTTONUP() 

END_MESSAGE_MAP()


BEGIN_MESSAGE_MAP(CBListBox, CListBox)
	//{{AFX_MSG_MAP(CBitListBox)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CBListBox::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	RECT rc;
	GetClientRect(&rc);
	
	CBrush br;
	br.CreateSolidBrush(RGB(115,138,154));
	dc.FillRect(&rc,&br);
	
	// Do not call CListBox::OnPaint() for painting messages
}




// CSkinComboBox message handlers

