#pragma once
#include "afxtempl.h" 
#include "SkinTypes.h" 

// CSkinComboBox



class CBListBox : public CListBox 
{
public:
	CBListBox(){};
	~CBListBox(){};
protected:
	afx_msg void OnPaint();

	DECLARE_MESSAGE_MAP()


}; 
class CSkinComboBox : public CComboBox
{
	DECLARE_DYNAMIC(CSkinComboBox)
private: 
	struct CBItemData : public CObject
	{
		CBitmap* bmpItem ; 
		CString strText ; 
		COLORREF m_clrText ; 
		COLORREF m_clrBkg ; 
		CFont* m_fontText ; 
	};	
public : 
	typedef CSkinComboBox::CBItemData* CBItemDataPtr ; 

public:
	CSkinComboBox();
	virtual ~CSkinComboBox();
	BOOL Create(CWnd* pParent,CRect& rect,UINT nID) ; 
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) ; 
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) ;
	void AddItem(int nIndex,CString strText,CBitmap* bmpItem,CFont* fontText,COLORREF clrText = RGB(0,0,0),COLORREF clrBkg = RGB(255,255,255)) ; 
	void SetBkColor (COLORREF clrBk) {	m_clrBk = clrBk ; } 
	void SetDropButtonBitmap (CBitmap* bmpButton)  {m_bmpButton = bmpButton ; } 
	
	CRect m_rcClientArea ;
	CRect rectWindow ; 

private : 
	CSize MeasureItemSize (CBItemData* cbData )  ;
	void DrawItem (CDC* pDC) ;
	COLORREF m_clrBk ; 
	CBitmap* m_bmpButton ; 
	CTypedPtrList<CObList,CBItemData*> m_aoItems ; 
	CSkinComboBox::CBItemData* GetItemData(int index)  ;
	CBListBox   m_listbox;
	

private: 
	afx_msg void OnPaint() ; 
	afx_msg HBRUSH OnCtlColor(CDC* pDC,CWnd* pWnd,UINT nCtlColor) ; 
	afx_msg void OnLButtonDown(UINT nFlags,CPoint point) ; 
	afx_msg void OnLButtonUp(UINT nFlags,CPoint point) ; 

	LRESULT OnCtlColorListBox(WPARAM wParam, LPARAM lParam);


protected:
	DECLARE_MESSAGE_MAP()
};




