// SkinListBox.cpp : implementation file
//

#include "stdafx.h"
//#include "SendPhotos.h"
#include "SkinListBox.h"


// CSkinListBox

IMPLEMENT_DYNAMIC(CSkinListBox, CListBox)
CSkinListBox::CSkinListBox()
{

}

CSkinListBox::~CSkinListBox()
{

}
BOOL CSkinListBox::Create(CWnd* pParent,CRect& rect,UINT nID) 
{
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_BORDER |  LBS_HASSTRINGS |  LBS_OWNERDRAWVARIABLE  ; 
	return CListBox::Create(dwStyle,rect,pParent,nID); 
	  
}

void CSkinListBox::PreSubclassWindow() 
{
	ModifyStyle(0,LBS_OWNERDRAWVARIABLE) ; 
	CListBox::PreSubclassWindow() ;

}

BOOL CSkinListBox::PreCreateWindow(CREATESTRUCT &cs) 
{
	cs.style |= LBS_OWNERDRAWVARIABLE ; 
	return CListBox::PreCreateWindow(cs); 	

}

void CSkinListBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CSkinListBox::LBItemData* lbData = NULL ;    
	CDC dc;
    CFont * pOldFont = NULL ; 
    HBITMAP pBmpOld = NULL ;  
    dc.Attach(lpDrawItemStruct->hDC);

	CRect rc = lpDrawItemStruct->rcItem ; 
	UINT nItem = lpDrawItemStruct->itemID ;
	if (nItem != -1) 
	{
		lbData = GetItemData(nItem) ; 
	}
	else 
	{
		int nSel = CListBox::GetCurSel(); 
		lbData = GetItemData(0) ; 
		 
	}
	
	HBITMAP bmpItem =lbData->bmpItem ; 
	CFont* font = lbData->m_fontText ; 
	COLORREF clrBkg = lbData->paColors[CLR_INTERIOR].clr ; 
	COLORREF clrText = lbData->paColors[CLR_TEXT].clr ; 
	COLORREF clrHilite = lbData->paColors[CLR_HILITE].clr ; 
	COLORREF clrFrame = lbData->paColors[CLR_FRAME].clr ;  
  
	
	
	    
  LPCTSTR lpszText = lbData->strText ;
  ASSERT(lpszText != NULL);

   
  if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
      (lpDrawItemStruct->itemState  & ODS_SELECTED))
   {
      
	  dc.FillSolidRect(&rc,clrHilite);
	  CBrush brush(clrFrame) ;
	   FrameRect(dc.m_hDC,&rc,brush) ; 
	  TRACE(_T("Selected \r\n"))  ; 
      
   }
 
   else
   {
	   dc.FillSolidRect(&rc,clrBkg );
	     TRACE(_T("UnSelected \r\n"))  ; 
   }

	  
	  if (bmpItem != NULL)
	  {
			CDC dcMem ; 
			dcMem.CreateCompatibleDC(&dc) ; 
			CBitmap bmp ; bmp.Attach(bmpItem) ; 
			BITMAP bmpInfo ; 
			bmp.GetBitmap(&bmpInfo) ; 
			pBmpOld = (HBITMAP)dcMem.SelectObject(bmpItem) ;  
		
			dc.BitBlt(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top,bmpInfo.bmWidth,bmpInfo.bmHeight,&dcMem,
					   0,0,SRCCOPY); 

			dcMem.SelectObject(pBmpOld) ;  
			bmp.Detach() ; 

	  
	   }
	   
	  if (font != NULL) 
	   {
		  pOldFont = dc.SelectObject(font) ;
		  dc.SetTextColor(clrText) ; 
		  if (bmpItem != NULL) 
		  {
			  CBitmap bmp ; bmp.Attach(bmpItem) ; 
			  BITMAP bmpInfo ; 
			  bmp.GetBitmap(&bmpInfo) ; 
			  rc.left += bmpInfo.bmWidth + 5 ; 
			  dc.DrawText(lpszText,wcslen(lpszText),&rc,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
			  bmp.Detach() ; 
		  }
		  else 
		  {
			  dc.DrawText(lpszText,wcslen(lpszText),&rc,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
		  }
	   }
	  else 
	  {
		  dc.SetTextColor(clrText) ;  
		  if (bmpItem != NULL) 
		  {
			  CBitmap bmp ; bmp.Attach(bmpItem) ;  
			  BITMAP bmpInfo ; 
			  bmp.GetBitmap(&bmpInfo) ; 
			  rc.left += bmpInfo.bmWidth + 5 ; 
			  dc.DrawText(lpszText,wcslen(lpszText),&rc,DT_LEFT | DT_SINGLELINE| DT_VCENTER);
			  bmp.Detach() ; 

		  }
		   else 
		   {
				dc.DrawText(lpszText,wcslen(lpszText),&rc,DT_LEFT | DT_SINGLELINE| DT_VCENTER); 
		   }
	  }

	
     if (pOldFont) 
	   dc.SelectObject(pOldFont) ; 
     
   dc.Detach();

}
void CSkinListBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemstruct) 
{	
	int nID = lpMeasureItemstruct->itemID;
	if (nID != -1  ) 
	{
		CSkinListBox::LBItemData* lbData = GetItemData(nID) ; 
		CSize sz = MeasureItemSize(lbData) ; 
	
		lpMeasureItemstruct->itemHeight = sz.cy ; 
		lpMeasureItemstruct->itemWidth  = sz.cx ; 
		
	}
}
CSkinListBox::LBItemData* CSkinListBox::GetItemData(int index)  
{
	int counter = 0 ; 
	CSkinListBox::LBItemData*  lbData  = NULL; 
	POSITION ps = m_aoItems.GetHeadPosition() ; 

	while (ps)
	{
		lbData = m_aoItems.GetAt(ps) ; 
		if (counter == index) 
			break ; 
		m_aoItems.GetNext(ps); 
		counter++; 
	}
	
	return lbData ; 

}
void CSkinListBox::AddItem(UINT nIndex,HBITMAP bmpItem,CFont* pFont,CString strText,COLORINDEX* paColors,UINT nCount) 
{
	CSkinListBox::LBItemData* itemData = new CSkinListBox::LBItemData() ;
	itemData->strText = strText ; 
	itemData->bmpItem = bmpItem ; 
	itemData->m_fontText = pFont ; 
	SetLBItemColors(itemData,paColors,nCount) ; 
	m_aoItems.AddTail(itemData) ; 

	CListBox::InsertString(nIndex,strText) ; 
	
}
void CSkinListBox::SetLBItemColors (CSkinListBox::LBItemData* lbData,COLORINDEX* paColors,UINT nCount)
{
	for (int i =0 ; i < nCount;i++) 
	{
		COLORINDEX index = paColors[i] ; 
		switch (index.nID) 
		{
			case CLR_TEXT :  lbData->paColors[CLR_TEXT] = index ; 
			case CLR_INTERIOR : lbData->paColors[CLR_INTERIOR] = index ; break ; 
			case CLR_HILITE: lbData->paColors[CLR_HILITE] = index ; break ;
			case CLR_FRAME: lbData->paColors[CLR_FRAME] = index ; break ;  
			case CLR_TEXT_DISABLED: lbData->paColors[CLR_TEXT_DISABLED] = index ;break ; 
			case CLR_DISABLED: lbData->paColors[CLR_DISABLED] = index ; break ;

		}
	}


}
CSize CSkinListBox::MeasureItemSize (CSkinListBox::LBItemData* itemData) 
{
	int nWidth = 0 ; 
	int nHeight = 0 ; 
		
	CString strText = itemData->strText ; 
	HBITMAP pBmp = itemData->bmpItem ; 
	CFont* pFont = itemData->m_fontText ; 
	
	CDC * pDC = GetDC() ; 
	CDC memDC ; 
	CFont* oldFont ; 
	memDC.CreateCompatibleDC(pDC) ; 

	if (pFont != NULL) 
	{
		oldFont = memDC.SelectObject(pFont) ;  
		CSize szText = memDC.GetTextExtent(strText) ;  
		
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

		BITMAP bmpInfo ;
		if (pBmp) 
		{		
			CBitmap bmp ; bmp.Attach(pBmp) ; 
			bmp.GetBitmap(&bmpInfo) ; 
			nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
			if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 
			bmp.Detach() ; 
			
		}	
	
	}
	else if (pBmp) 
	{
		CBitmap bmp ; bmp.Attach(pBmp) ; 
		BITMAP bmpInfo ; 
		bmp.GetBitmap(&bmpInfo) ; 
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
		if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 

		bmp.Detach() ; 

	}
	else 
	{
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

	}

	if (pFont != NULL)
	{
		memDC.SelectObject(oldFont) ;
	}

	return CSize(nWidth,nHeight) ; 


}


void CSkinListBox::SetItemBitmap(UINT nIndex,HBITMAP bmpItem) 
{
	CSkinListBox::LBItemData* lbData = GetItemData(nIndex) ; 
	DeleteObject(lbData->bmpItem) ; 
	lbData->bmpItem = 0 ; 
	lbData->bmpItem = bmpItem ;
	//Invalidate() ; 
    

}
void CSkinListBox::SetItemText (UINT nIndex,CString strText,COLORREF clrText,CFont* font) 
{
	CSkinListBox::LBItemData* lbData = GetItemData(nIndex) ; 
	if (clrText != 0) 
		lbData->paColors[CLR_TEXT].clr = clrText ; 
	if (font != NULL)
		{
			DeleteObject(lbData->m_fontText); 
			delete lbData->m_fontText ; lbData->m_fontText = 0 ; 
			lbData->m_fontText = font ; 
		}
		
	lbData->strText = strText ; 
	//Invalidate() ; 

}


BOOL CSkinListBox::OnEraseBkgnd(CDC* pDC) 
{
	CRect rectClient ; 
	GetClientRect(&rectClient) ; 
	pDC->FillSolidRect(&rectClient,m_clrBkg) ; 
	return TRUE ;
	//return CListBox::OnEraseBkgnd(pDC) ; 

}

BEGIN_MESSAGE_MAP(CSkinListBox, CListBox)
	ON_WM_ERASEBKGND() 
END_MESSAGE_MAP()



// CSkinListBox message handlers

