#pragma once
#include "afxtempl.h"  
#include "SkinTypes.h" 


// CSkinListBox


class CSkinListBox : public CListBox
{
	DECLARE_DYNAMIC(CSkinListBox)


public: 
	struct LBItemData : public CObject 
	{
		HBITMAP bmpItem ; 
		CString strText ;
		CFont* m_fontText ; 
		COLORINDEX paColors[6] ;
	} ; 
	
public : 
	typedef CSkinListBox::LBItemData* LBItemDataPtr ; 


public:
	CSkinListBox();
	virtual ~CSkinListBox();
	BOOL Create(CWnd* pParent,CRect& rect,UINT nID);
	
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) ; 
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemstruct) ;
	virtual void PreSubclassWindow() ;
	virtual BOOL PreCreateWindow(CREATESTRUCT &cs) ; 

	void AddItem(UINT nIndex,HBITMAP bmpItem,CFont* pFont,CString strText,COLORINDEX* paColors,UINT nCount) ; 
	void SetItemBitmap(UINT nIndex,HBITMAP bmpItem) ; 
	void SetItemText (UINT nIndex,CString strText,COLORREF clrText = 0,CFont* font = NULL) ; 
	void SetBkColor(COLORREF clrBkg) {m_clrBkg = clrBkg ;} 
	


private :
	CSize MeasureItemSize (CSkinListBox::LBItemData* itemData) ;
	void SetLBItemColors (CSkinListBox::LBItemData* lbData,COLORINDEX* paColors,UINT nCount);
	CSkinListBox::LBItemData* GetItemData(int index) ;
	afx_msg BOOL OnEraseBkgnd(CDC* pDC) ;
	

private :
	CTypedPtrList<CObList,CSkinListBox::LBItemData*> m_aoItems; 
	COLORREF m_clrBkg ; 
    



protected:
	DECLARE_MESSAGE_MAP()
};


