#pragma once
#include "afxwin.h"
#include "afxtempl.h" 
#include "SkinTypes.h" 


struct MenuData : public CObject 
{
	MenuData() { 
		UINT nID = -1 ; 
		bmpItem = NULL  ; 
		bmpUchecked = NULL ; 
		fontText = NULL ; 
		strText = _T("") ; 
		clrText = 0; ; 
		clrHiLite = 0 ; 
		clrBkg = 0 ; 
		clrTxtDisable = 0 ; 
		clrItemDisable = 0 ; 
		cltBorder =0  ; 
	}; 

	
	UINT nID ; 
	HBITMAP bmpItem  ; 
	HBITMAP bmpUchecked ; 
	CFont* fontText ; 
	CString strText ; 
	COLORREF clrText ; 
	COLORREF clrHiLite ; 
	COLORREF clrBkg ; 
	COLORREF clrTxtDisable ; 
	COLORREF clrItemDisable ; 
	COLORREF cltBorder ; 
} ;

class CSkinMenu :
	public CMenu
{
public:
	CSkinMenu(void);
	~CSkinMenu(void);
public: 
	virtual void DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct) ;
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) ;

void AppendMenuItem(int nID,HBITMAP bmpItem,CFont* fontText,CString strText,COLORINDEX* paColors,UINT nCount) ;
void AppendCheckedMenuItem (int nID,HBITMAP bmpItem,HBITMAP  bmpUnchecked,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount) ;
void AppendMenuItem2(int nID,UINT uBmpResItemID,CFont* fontText,CString strText,COLORINDEX* paColors,UINT nCount) ;
void AppendCheckedMenuItem (int nID,UINT uBmpResItemID,UINT uBmpResUncheckedItemID,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount) ; 
void AppendSeparator(int nID,UINT uBmpResItemID,COLORREF clrBkg,COLORREF clrInterior);
void AppenPopUpMenu (int nID,CSkinMenu* menuPopUp,HBITMAP bmpItem,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount) ; 

			
private : 
	COLORINDEX m_clrSchema [6]; 
	CSize MeasureItemSize (UINT nID)  ; 
	MenuData* GetItemData(UINT nID) ; 
	void SetMenuItemColors (MenuData* menuData,COLORINDEX* paColors,UINT nCount);
	BOOL IsBitmapMenuItems (CSize& sz) ; 
	void DrawItem(CDC* pDC,LPDRAWITEMSTRUCT lpDrawStruct,MenuData* menuData) ;  
	CTypedPtrList<CObList,MenuData*> m_aoItems  ; 

}; 


