// client\SkinStatic.cpp : implementation file
//
#include "stdafx.h"
#include "SkinStatic.h"

// CSkinStatic

IMPLEMENT_DYNAMIC(CSkinStatic, CStatic)

CSkinStatic::CSkinStatic()
{

}

CSkinStatic::~CSkinStatic()
{
	m_skinTxtFont.DeleteObject() ;

}

BOOL CSkinStatic::Create(CString strFile,CWnd* pParent,UINT nID) 
{
	
	LONG dwStyleEx = GetWindowLong(pParent->m_hWnd,GWL_EXSTYLE) ; 
	m_bLayered =  dwStyleEx & WS_EX_LAYERED ?  TRUE : FALSE  ; 
	
	m_skinLabel.ReadPGF(strFile) ; 
	BITMAP bmpInfo ; 
	m_skinLabel.GetBitmap(&bmpInfo) ; 
	
	m_strText = _T("Some text") ; 

	GetDefaultFont(m_skinTxtFont) ; 
	m_uAlignText = DT_CENTER ;  
    
	CRect rectWnd (m_skinLabel.m_ptPosition.x,m_skinLabel.m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight) ; 
		
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY | SS_OWNERDRAW ; 
	BOOL bCreate = CStatic::Create(_T(""),dwStyle,rectWnd,pParent,nID) ; 

	HRGN hRgn = m_skinLabel.GetWindowRegion() ; 
	int nRet = SetWindowRgn(hRgn,TRUE) ; 
	
	return TRUE ; 

}
BOOL CSkinStatic::Create(CString strFile,CWnd* pParent,UINT nID,CPoint point) 
{
	LONG dwStyleEx = GetWindowLong(pParent->m_hWnd,GWL_EXSTYLE) ; 
	m_bLayered =  dwStyleEx & WS_EX_LAYERED ?  TRUE : FALSE  ; 
	
	m_skinLabel.m_ptPosition.x = point.x ; 
	m_skinLabel.m_ptPosition.y = point.y ; 

	m_skinLabel.LoadBitmapEx(strFile) ; 
	
	BITMAP bmpInfo ; 
	m_skinLabel.GetBitmap(&bmpInfo) ; 
	
	m_strText = _T("Some text") ; 
	GetDefaultFont(m_skinTxtFont) ; 
	m_uAlignText = DT_CENTER ; 
	CRect rectWnd (m_skinLabel.m_ptPosition.x,m_skinLabel.m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight) ; 
		
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY | SS_OWNERDRAW ; 
	BOOL bCreate = CStatic::Create(_T(""),dwStyle,rectWnd,pParent,nID) ; 

	HRGN hRgn = m_skinLabel.GetWindowRegion() ; 
	int nRet = SetWindowRgn(hRgn,TRUE) ; 
	
	return TRUE ; 
}
BOOL CSkinStatic::Create(CWnd* pParent,UINT nID,CPoint point)
{
	m_skinLabel.m_ptPosition.x = point.x ; 
	m_skinLabel.m_ptPosition.y = point.y ; 
	
	m_uAlignText = DT_CENTER ; 

	CreateAlphaBitmap(m_strText) ; 
	
	BITMAP bmpInfo ; 
	m_skinLabel.GetBitmap(&bmpInfo) ; 

	CRect rectWnd (m_skinLabel.m_ptPosition.x,m_skinLabel.m_ptPosition.y,bmpInfo.bmWidth,bmpInfo.bmHeight) ; 
		
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY | SS_OWNERDRAW ; 
	
	BOOL bCreate = CStatic::Create(_T(""),dwStyle,rectWnd,pParent,nID) ; 

	//HRGN hRgn = m_skinLabel.GetWindowRegion() ; 
	//int nRet = SetWindowRgn(hRgn,TRUE) ;
	
	return TRUE ; 

}


BOOL CSkinStatic::CreateAlphaBitmap (CString strText) 
{
	
	HDC  hDC = ::GetDC(NULL); 
	CDC* pDC = CDC::FromHandle(hDC); 
	UINT w,h ; 

	CFont* pOldFont = pDC->SelectObject(&m_skinTxtFont) ; 
	CSize szText = pDC->GetTextExtent(m_strText) ; 
	
	w = szText.cx ; 
	h = szText.cy ; 
	size_t size = w*h*4 ; 

	m_skinLabel.w = w ; 
	m_skinLabel.h = h ;

	BYTE *pMask = DEBUG_NEW BYTE[size] ; 
	memset(pMask,0,size) ; 
		
	UINT xPos = m_skinLabel.m_ptPosition.x ; 
	UINT yPos = m_skinLabel.m_ptPosition.y ; 

	CRect rect(0,0,w,h) ; 
	LOGFONT lg ; 
	m_skinTxtFont.GetLogFont(&lg) ; 
	
	USES_CONVERSION ; 
	
	IS40_DrawTextOnRGBA2(pMask,w,h,w*4,W2A(m_strText),&lg,&rect,DT_LEFT ,0 ,m_clrText) ; 
			
	HGLOBAL m_hDib = IS40_RGBAToDIB((LPBYTE)pMask,w,h,w * 4,NULL,0) ;

	if (m_hDib == NULL) 
	{
		delete [] pMask ; 
		pDC->SelectObject(pOldFont) ; 
		::ReleaseDC(NULL,hDC) ; 
		GlobalFree(m_hDib) ; 
		return FALSE ; 		

	}
	
	m_skinLabel.DeleteObject() ; 

	m_skinLabel.m_hObject = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)m_hDib,NULL,hDC) ;

	if(m_skinLabel.m_hObject == NULL)
	{
		
		GlobalFree(m_hDib) ; 
		delete [] pMask ; 
		pDC->SelectObject(pOldFont) ; 
		::ReleaseDC(NULL,hDC) ;  
		return FALSE ; 
	}

	delete [] pMask ; 
	GlobalFree(m_hDib) ; 
	pDC->SelectObject(pOldFont) ;
	::ReleaseDC(NULL,hDC) ;  


	return TRUE ; 
}

void CSkinStatic::DrawItem(LPDRAWITEMSTRUCT lpDrawStruct) 
{

	CDC* pDC = CDC::FromHandle(lpDrawStruct->hDC) ; 
	CFont* pOldFont = pDC->SelectObject(&m_skinTxtFont) ;
	CSize szName = pDC->GetTextExtent(m_strText) ; 
	CRect rectText(0,0,szName.cx,szName.cy) ;  
	
	pDC->SetBkMode(TRANSPARENT) ; 
	pDC->SetTextColor(m_clrText) ;
	pDC->DrawText(m_strText,&rectText,m_uAlignText) ;


}
void CSkinStatic::Draw(CDC* dcMemory) 
{
	CreateAlphaBitmap(m_strText) ; 

	CDC dcName ; 
	dcName.CreateCompatibleDC(dcMemory) ;  

	CBitmap* pBmpOld = dcName.SelectObject(&m_skinLabel) ;  

	BITMAP bmpInfo ; 
	m_skinLabel.GetBitmap(&bmpInfo) ; 

	CPoint point (m_skinLabel.m_ptPosition) ;
	BLENDFUNCTION blend = {AC_SRC_OVER,0,255,AC_SRC_ALPHA} ; 
	dcMemory->AlphaBlend(point.x,point.y,bmpInfo.bmWidth,bmpInfo.bmHeight,&dcName,0,0,bmpInfo.bmWidth,bmpInfo.bmHeight,blend) ;

	dcName.SelectObject(pBmpOld) ; 
	dcName.DeleteDC() ;

}

void CSkinStatic::Paint() 
{
	if (m_bLayered) 
	{
		::SendMessage(GetParent()->m_hWnd,WM_PAINT,NULL,NULL) ; 
    }
	else 
	{
		Invalidate(FALSE) ; 
	}

}
void CSkinStatic::GetDefaultFont(CFont& font) 
{
	LOGFONT LogFont;
	LogFont.lfCharSet = DEFAULT_CHARSET ; 
	LogFont.lfQuality = DEFAULT_QUALITY ; 
	LogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS ; 
	LogFont.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	LogFont.lfOutPrecision = OUT_DEFAULT_PRECIS ; 
	LogFont.lfUnderline = FALSE ; 
	LogFont.lfStrikeOut = FALSE ; 
	LogFont.lfItalic = FALSE ; 
	LogFont.lfWeight = FALSE ; //parametar 
	LogFont.lfOrientation = 0 ; 
	LogFont.lfEscapement = 0 ; 
	_tcsncpy (LogFont.lfFaceName, _T("Verdana"), LF_FACESIZE);
	LogFont.lfFaceName[LF_FACESIZE-1] = TEXT('\0');  // Ensure null termination
	LogFont.lfHeight = 12; 
	LogFont.lfWidth = 0; 
	font.CreateFontIndirect(&LogFont); 


}
BEGIN_MESSAGE_MAP(CSkinStatic, CStatic)
END_MESSAGE_MAP()



// CSkinStatic message handlers

