#pragma once

#include "GDIBitmap.h" 


#define MATCH_COLOR(clr,_clr) (GetRValue(clr) == GetRValue(_clr) && GetGValue(clr) == GetGValue(_clr) && GetBValue(clr) == GetBValue(_clr))
#define GetAValue(rgb)       ((BYTE)((rgb)>>24))
// CSkinStatic

class CSkinStatic : public CStatic
{
	DECLARE_DYNAMIC(CSkinStatic)

public:
	CSkinStatic();
	virtual ~CSkinStatic();

	BOOL Create(CString strFile,CWnd* pParent,UINT nID) ; 
	BOOL Create(CString strFile,CWnd* pParent,UINT nID,CPoint point) ;
	BOOL Create(CWnd* pParent,UINT nID,CPoint point) ; 

	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawStruct) ; 
	virtual void Draw(CDC* dcMemory) ; 

	void SetFont(CFont* pFont) 
	{ 
		if (pFont)
		{
			m_skinTxtFont.DeleteObject() ; 
			LOGFONT lgFont ; 
			pFont->GetLogFont(&lgFont) ; 
			m_skinTxtFont.CreateFontIndirect(&lgFont) ; 
			
		}
	} 

	void SetFont (CString szFontName,LONG lSize,LONG lBold) 
	{
		m_skinTxtFont.DeleteObject() ; 

		LOGFONT LogFont;
		LogFont.lfCharSet = DEFAULT_CHARSET ; 
		LogFont.lfQuality = DEFAULT_QUALITY ; 
		LogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS ; 
		LogFont.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
		LogFont.lfOutPrecision = OUT_DEFAULT_PRECIS ; 
		LogFont.lfUnderline = FALSE ; 
		LogFont.lfStrikeOut = FALSE ; 
		LogFont.lfItalic = FALSE ; 
		LogFont.lfWeight = lBold ; //parametar 
		LogFont.lfOrientation = 0 ; 
		LogFont.lfEscapement = 0 ; 
		_tcsncpy (LogFont.lfFaceName, szFontName, LF_FACESIZE);
		LogFont.lfFaceName[LF_FACESIZE-1] = TEXT('\0');  // Ensure null termination
		LogFont.lfHeight = lSize; 
		LogFont.lfWidth = 0; 
		m_skinTxtFont.CreateFontIndirect(&LogFont); 

	

	
	}
    void SetTextColor(COLORREF clr) { m_clrText = clr ;}  
	void SetTextAlignment (UINT uAlignText) { m_uAlignText = uAlignText ;} 
	void SetText(CString strText) { m_strText = strText ; } 
	BOOL CreateAlphaBitmap (CString strText) ; 
	


protected : 
	void Paint() ; 
	void GetDefaultFont(CFont& font) ;  


private : 
	CGDIStatic m_skinLabel ; 
	CFont m_skinTxtFont  ;
	CString m_strText ; 
	COLORREF m_clrText ; 
	UINT m_uAlignText ; 
	BOOL m_bLayered ; 


protected:
	DECLARE_MESSAGE_MAP()
};


