#include "StdAfx.h"
#include ".\utils.h"
#include "..\resource.h" 

CUtils::CUtils(void)
{
}

CUtils::~CUtils(void)
{
}
CSize CUtils::CalcAspectSize(CSize ptOriginalSize, CSize ptWantedSize)
{
	CSize ptNewSize;

	// utvrdi da li je u pitanju landscape ili portrait
	bool bIsPortrait = IsPortrait(ptOriginalSize);

	// odredi aspect ratio koji je sada >= 1
	double dAspectRatio;

	if (bIsPortrait)
	{
		// ukoliko je slika portrait odredi aspect po visini slike
		dAspectRatio = (double)ptOriginalSize.cy / (double)ptOriginalSize.cx;
		// setujem visinu kao fiksnu vrednost		
		ptNewSize.cx = ptWantedSize.cy / dAspectRatio;
		ptNewSize.cy = ptWantedSize.cy;
	}
	else
	{
		// ukoliko je landscape odredi aspect po duzini slike
		dAspectRatio = (double)ptOriginalSize.cx / (double)ptOriginalSize.cy;
		// setujem sirinu kao fiksnu vrednost
		ptNewSize.cx = ptWantedSize.cx;
		ptNewSize.cy = ptWantedSize.cx / dAspectRatio;
	}

	return ptNewSize;
}

CSize CUtils::CalcAspectSizeMN(CSize ptOriginalSize, CSize ptWantedSize)
{
	CSize ptNewSize;

	// utvrdi da li je u pitanju landscape ili portrait
	bool bIsPortraitOriginal = IsPortrait(ptOriginalSize);
	bool bIsPortraitWanted = IsPortrait(ptWantedSize);

	// ako nisu oba iste orijentacije, rotiraj ptWanted
	//ptWantedSize = CPoint(ptWantedSize.cy, ptWantedSize.cx);

	// odredi aspect ratio koji je sada >= 1
	double dAspectRatio;

	if (bIsPortraitOriginal)
	{
		// ukoliko je slika portrait odredi aspect po visini slike
		dAspectRatio = (double)ptOriginalSize.cy / (double)ptOriginalSize.cx;
		// setujem visinu kao fiksnu vrednost		
		ptNewSize.cx = ptWantedSize.cy / dAspectRatio;
		ptNewSize.cy = ptWantedSize.cy;
	}
	else
	{
		// ukoliko je landscape odredi aspect po duzini slike
		dAspectRatio = (double)ptOriginalSize.cx / (double)ptOriginalSize.cy;
		// setujem sirinu kao fiksnu vrednost
		ptNewSize.cx = ptWantedSize.cx;
		ptNewSize.cy = ptWantedSize.cx / dAspectRatio;
	}

	CString strTemp;
	strTemp.Format(_T("(%d, %d)"), ptNewSize.cx, ptNewSize.cy);
	//AfxMessageBox(strTemp);


	// da li je zeljena kraca strana veca od zadate?
	// ako jeste preracunaj sve, samo gledaj manju stranicu tj. kontra parametar...
	if ((bIsPortraitOriginal && ptNewSize.cx > ptWantedSize.cx) || (!bIsPortraitOriginal && ptNewSize.cy > ptWantedSize.cy))
	{
		if (!bIsPortraitOriginal)
		{
			// ukoliko je slika portrait odredi aspect po visini slike
			dAspectRatio = (double)ptOriginalSize.cy / (double)ptOriginalSize.cx;
			// setujem visinu kao fiksnu vrednost		
			ptNewSize.cx = ptWantedSize.cy / dAspectRatio;
			ptNewSize.cy = ptWantedSize.cy;
		}
		else
		{
			// ukoliko je landscape odredi aspect po duzini slike
			dAspectRatio = (double)ptOriginalSize.cx / (double)ptOriginalSize.cy;
			// setujem sirinu kao fiksnu vrednost
			ptNewSize.cx = ptWantedSize.cx;
			ptNewSize.cy = ptWantedSize.cx / dAspectRatio;
		}
	}

	strTemp.Format(_T("(%d, %d)"), ptNewSize.cx, ptNewSize.cy);
	//AfxMessageBox(strTemp);

	// Valjda bi sad MN fitovanje bilo zavrseno....
	return ptNewSize;

}

bool CUtils::IsPortrait(CSize ptImageSize)
{
	bool bIsPortrait = true;
	
	if (ptImageSize.cx >= ptImageSize.cy)
		bIsPortrait = false;

	return bIsPortrait;
}

CString CUtils::LoadResourceString(int iResID)
{
	USES_CONVERSION;
	CComBSTR bstrTemp;
		
	CString strPath ; 
	
	//strPath = GetModuleLangPath() ; 
	
	HMODULE hLangResource = LoadLibrary(strPath) ; 

	if (hLangResource == NULL)
	{
		bstrTemp.LoadString(iResID);
	}
	else 
	{
		bstrTemp.LoadString(hLangResource,iResID);
	}
	
	//IDS_PROJNAME proj name stored as resource in string table
	
	FreeLibrary(hLangResource) ; 
	CString strRet = bstrTemp ; 

	return strRet ; 
}
CComBSTR CUtils::LoadResourceStringEx(int iResID)
{
	//USES_CONVERSION;
	CComBSTR bstrTemp;
	CString strPath; 

	
	//strPath = GetModuleLangPath() ; 
  	
	HMODULE hLangResource = LoadLibrary(strPath) ; 
	if (hLangResource == NULL)
	{
		bstrTemp.LoadString(iResID);
	}
	else 
	{
		bstrTemp.LoadString(hLangResource,iResID);
	}
	
	//IDS_PROJNAME proj name stored as resource in string table
		
	FreeLibrary(hLangResource) ; 
	
	return bstrTemp ; 



}
CString CUtils::LoadResourceHTML(int iResID) 
{
	HRSRC hRes = FindResource(NULL,MAKEINTRESOURCE(iResID),RT_HTML) ;
	HGLOBAL hHeader = LoadResource(NULL,hRes);  
	CString strHtml = (LPCTSTR)LockResource(hHeader) ; 
	UnlockResource(hHeader) ; 
	FreeResource(hRes) ; 
	return strHtml ; 

}
void CUtils::GetDefaultFont(CFont& font) 
 {
	LOGFONT LogFont;
	LogFont.lfCharSet = DEFAULT_CHARSET ; 
	LogFont.lfQuality = DEFAULT_QUALITY ; 
	LogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS ; 
	LogFont.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	LogFont.lfOutPrecision = OUT_DEFAULT_PRECIS ; 
	LogFont.lfUnderline = FALSE ; 
	LogFont.lfStrikeOut = FALSE ; 
	LogFont.lfItalic = FALSE ; 
	LogFont.lfWeight = FW_NORMAL ; //parametar 
	LogFont.lfOrientation = 0 ; 
	LogFont.lfEscapement = 0 ; 
	_tcsncpy (LogFont.lfFaceName, _T("Verdana"), LF_FACESIZE);
	LogFont.lfFaceName[LF_FACESIZE-1] = TEXT('\0');  // Ensure null termination
	LogFont.lfHeight = 12; 
	LogFont.lfWidth = 0; 
	
	font.CreateFontIndirect(&LogFont); 



 }
 void CUtils::GetNamedFont(CFont& font,LPCWSTR szFontName,LONG lSize,LONG lBold) 
 {
	LOGFONT LogFont;
	LogFont.lfCharSet = DEFAULT_CHARSET ; 
	LogFont.lfQuality = DEFAULT_QUALITY ; 
	LogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS ; 
	LogFont.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	LogFont.lfOutPrecision = OUT_DEFAULT_PRECIS ; 
	LogFont.lfUnderline = FALSE ; 
	LogFont.lfStrikeOut = FALSE ; 
	LogFont.lfItalic = FALSE ; 
	LogFont.lfWeight = lBold ; //parametar 
	LogFont.lfOrientation = 0 ; 
	LogFont.lfEscapement = 0 ; 
	_tcsncpy (LogFont.lfFaceName, szFontName, LF_FACESIZE);
	LogFont.lfFaceName[LF_FACESIZE-1] = TEXT('\0');  // Ensure null termination
	LogFont.lfHeight = lSize; 
	LogFont.lfWidth = 0; 
	font.CreateFontIndirect(&LogFont); 

 }

 void CUtils::GetShortPathName(LPCWSTR pszFileName,LPWSTR pszOut) 
{
	
	CreateFileEx(pszFileName) ; 
	::GetShortPathName(pszFileName,pszOut,MAX_PATH) ;
	  

}
 bool CUtils::CreateFileEx (LPCWSTR pszFileName)
{
	HANDLE hFile;
	if (!FileExists(pszFileName))
		{
			hFile = ::CreateFile(pszFileName, 0, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hFile != INVALID_HANDLE_VALUE) 
			{
				CloseHandle(hFile);
				return true;
			}
			else 
			{
				return false;	
			}
		}
	else 
	{
		return true ; 
	}
						
}
 bool CUtils ::FileExists(LPCWSTR szFileName)
{
	HANDLE hFile;
	
	hFile = CreateFile (szFileName, 0, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if (hFile != INVALID_HANDLE_VALUE) 
	{
		CloseHandle(hFile);
		return true;
	}
	else 
	{
		DWORD dwError = GetLastError() ; 
		TCHAR szMessage [MAX_PATH]; 
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,dwError,NULL,szMessage,MAX_PATH,NULL); 
		CString strMessage(szMessage) ;
		CString strMsg ;
		strMsg.Format(_T("%s %s"),strMessage,szFileName) ; 
		//AfxMessageBox(strMsg) ; 


	}
	return false;
}
CBitmap* CUtils::LoadBitmapEx(LPCWSTR lpsFileName) 
{
	HISSRC hSrc;
	HGLOBAL hOriginalRGB = NULL;
	UINT32 w, h;
	RGBQUAD Palette[256];

	USES_CONVERSION ; 

	TCHAR psPath [MAX_PATH] ; 
	CUtils::GetShortPathName(lpsFileName,psPath) ; 

	hSrc = IS40_OpenFileSource(W2A(psPath)) ;  
	
	IS40_Seek(hSrc,0,0); 
	
	hOriginalRGB = IS40_ReadPNG(hSrc, &w, &h, 32, Palette,0);

	PreMultiplyRGBChannels((LPBYTE)hOriginalRGB,w,h); 
	
	IS40_CloseSource(hSrc) ;

	HGLOBAL hDib = IS40_RGBAToDIB((LPBYTE)hOriginalRGB,w,h,w * 4,NULL,0) ; 

	HDC hDC = ::GetDC(NULL) ; 

	HBITMAP hBitmap = IS40_DIBToHBITMAP((BITMAPINFOHEADER*)hDib,NULL,hDC) ;

	::ReleaseDC(NULL,hDC) ; 

	CBitmap* pBitmap = new CBitmap() ; 
	
	pBitmap->Attach(hBitmap); 

	GlobalFree(hOriginalRGB) ; 
	
	GlobalFree(hDib) ; 
	
	GlobalFree(hBitmap) ; 
	
	return pBitmap ;

    
}
HGLOBAL CUtils::GetBackGround(LPCWSTR lpsFileName) 
{
	HISSRC hSrc;
	HGLOBAL hOriginalRGB = NULL;
	UINT32 w, h;
	RGBQUAD Palette[256];

	USES_CONVERSION ; 

	TCHAR psPath [MAX_PATH] ; 
	CUtils::GetShortPathName(lpsFileName,psPath) ; 

	hSrc = IS40_OpenFileSource(W2A(psPath)) ;  
	IS40_Seek(hSrc,0,0); 
	
	hOriginalRGB = IS40_ReadPNG(hSrc, &w, &h, 32, Palette,0);

	PreMultiplyRGBChannels((LPBYTE)hOriginalRGB,w,h); 

	HGLOBAL hDib = IS40_RGBAToDIB((LPBYTE)hOriginalRGB,w,h,w * 4,NULL,0) ; 


	IS40_CloseSource(hSrc) ;

	return hDib ; 

}
HRGN CUtils::BitmapToRegion (HBITMAP hBmp, COLORREF cTransparentColor, COLORREF cTolerance)
{
	HRGN hRgn = NULL;

	if (hBmp)
	{
		// Create a memory DC inside which we will scan the bitmap content
		HDC hMemDC = ::CreateCompatibleDC(NULL);
		if (hMemDC)
		{
			// Get bitmap size
			BITMAP bm;
			::GetObject(hBmp, sizeof(bm), &bm);

			// Create a 32 bits depth bitmap and select it into the memory DC 
			BITMAPINFOHEADER RGB32BITSBITMAPINFO = {	
					sizeof(BITMAPINFOHEADER),	// biSize 
					bm.bmWidth,					// biWidth; 
					bm.bmHeight,				// biHeight; 
					1,							// biPlanes; 
					32,							// biBitCount 
					BI_RGB,						// biCompression; 
					0,							// biSizeImage; 
					0,							// biXPelsPerMeter; 
					0,							// biYPelsPerMeter; 
					0,							// biClrUsed; 
					0							// biClrImportant; 
			};
			VOID * pbits32; 
			HBITMAP hbm32 = ::CreateDIBSection(hMemDC, (BITMAPINFO *)&RGB32BITSBITMAPINFO, DIB_RGB_COLORS, &pbits32, NULL, 0);
			if (hbm32)
			{
				HBITMAP holdBmp = (HBITMAP)::SelectObject(hMemDC, hbm32);

				// Create a DC just to copy the bitmap into the memory DC
				HDC hDC = ::CreateCompatibleDC(hMemDC);
				if (hDC)
				{
					// Get how many bytes per row we have for the bitmap bits (rounded up to 32 bits)
					BITMAP bm32;
					::GetObject(hbm32, sizeof(bm32), &bm32);
					while (bm32.bmWidthBytes % 4)
						bm32.bmWidthBytes++;

					// Copy the bitmap into the memory DC
					HBITMAP holdBmp = (HBITMAP)::SelectObject(hDC, hBmp);
					::BitBlt(hMemDC, 0, 0, bm.bmWidth, bm.bmHeight, hDC, 0, 0, SRCCOPY);

					// For better performances, we will use the ExtCreateRegion() function to create the
					// region. This function take a RGNDATA structure on entry. We will add rectangles by
					// amount of ALLOC_UNIT number in this structure.
					#define ALLOC_UNIT	100
					DWORD maxRects = ALLOC_UNIT;
					HANDLE hData = ::GlobalAlloc(GMEM_MOVEABLE, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects));
					RGNDATA *pData = (RGNDATA *)::GlobalLock(hData);
					pData->rdh.dwSize = sizeof(RGNDATAHEADER);
					pData->rdh.iType = RDH_RECTANGLES;
					pData->rdh.nCount = pData->rdh.nRgnSize = 0;
					::SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);

					// Keep on hand highest and lowest values for the "transparent" pixels
					BYTE lr = GetRValue(cTransparentColor);
					BYTE lg = GetGValue(cTransparentColor);
					BYTE lb = GetBValue(cTransparentColor);
					BYTE hr = min(0xff, lr + GetRValue(cTolerance));
					BYTE hg = min(0xff, lg + GetGValue(cTolerance));
					BYTE hb = min(0xff, lb + GetBValue(cTolerance));

					// Scan each bitmap row from bottom to top (the bitmap is inverted vertically)
					BYTE *p32 = (BYTE *)bm32.bmBits + (bm32.bmHeight - 1) * bm32.bmWidthBytes;
					for (int y = 0; y < bm.bmHeight; y++)
					{
						// Scan each bitmap pixel from left to right
						for (int x = 0; x < bm.bmWidth; x++)
						{
							// Search for a continuous range of "non transparent pixels"
							int x0 = x;
							LONG *p = (LONG *)p32 + x;
							while (x < bm.bmWidth)
							{
								BYTE b = GetRValue(*p);
								BYTE green = GetGValue(*p); 
								BYTE blue = GetBValue(*p) ;

								if (b >= lr && b <= hr)
								{
									b = GetGValue(*p);
									if (b >= lg && b <= hg)
									{
										b = GetBValue(*p);
										if (b >= lb && b <= hb)
											// This pixel is "transparent"
											break;
									}
								}
								p++;
								x++;
							}

							if (x > x0)
							{
								// Add the pixels (x0, y) to (x, y+1) as a new rectangle in the region
								if (pData->rdh.nCount >= maxRects)
								{
									::GlobalUnlock(hData);
									maxRects += ALLOC_UNIT;
									hData = ::GlobalReAlloc(hData, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), GMEM_MOVEABLE);
									pData = (RGNDATA *)::GlobalLock(hData);
								}
								RECT *pr = (RECT *)&pData->Buffer;
								::SetRect(&pr[pData->rdh.nCount], x0, y, x, y+1);
								if (x0 < pData->rdh.rcBound.left)
									pData->rdh.rcBound.left = x0;
								if (y < pData->rdh.rcBound.top)
									pData->rdh.rcBound.top = y;
								if (x > pData->rdh.rcBound.right)
									pData->rdh.rcBound.right = x;
								if (y+1 > pData->rdh.rcBound.bottom)
									pData->rdh.rcBound.bottom = y+1;
								pData->rdh.nCount++;

								// On Windows98, ExtCreateRegion() may fail if the number of rectangles is too
								// large (ie: > 4000). Therefore, we have to create the region by multiple steps.
								if (pData->rdh.nCount == 2000)
								{
									HRGN h = ::ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pData);
									if (hRgn)
									{
										::CombineRgn(hRgn, hRgn, h, RGN_OR);
										::DeleteObject(h);
									}
									else
										hRgn = h;
									pData->rdh.nCount = 0;
									::SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);
								}
							}
						}

						// Go to next row (remember, the bitmap is inverted vertically)
						p32 -= bm32.bmWidthBytes;
					}

					// Create or extend the region with the remaining rectangles
					HRGN h = ::ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pData);
					if (hRgn)
					{
						::CombineRgn(hRgn, hRgn, h, RGN_OR);
						::DeleteObject(h);
					}
					else
						hRgn = h;

					// Clean up
					::GlobalFree(hData);
					::SelectObject(hDC, holdBmp);
					::DeleteDC(hDC);
				}

				::DeleteObject(::SelectObject(hMemDC, holdBmp));
			}

			::DeleteDC(hMemDC);
		}	
	}

	return hRgn;
}

void CUtils::PreMultiplyRGBChannels(LPBYTE hImg,UINT32& w,UINT32& h)
{
	for (int y=0; y<h;++y)
	{
		for (int x=0; x<w ;++x)
		{
			BYTE* pPixel = hImg + x * 4 + y * w * 4 ;
			pPixel[0]= pPixel[0]*pPixel[3]/255;
			pPixel[1]= pPixel[1]*pPixel[3]/255;
			pPixel[2]= pPixel[2]*pPixel[3]/255;
			pPixel+= 4;
		}
	}


}
void CUtils::CenterImage (UINT x,UINT y, CRect& rectAfter,UINT& xPos , UINT& yPos) 
{

	UINT xFrame = rectAfter.Width(); 
	UINT yFrame = rectAfter.Height(); 

		
	if (x >= xFrame && y >= yFrame) 
	{
		if (xFrame < x ) xPos = 0 ; 
		else xPos = (xFrame / 2) - (x / 2) ; 
				
		if (yFrame < y ) yPos = 0 ; 
		else yPos = (yFrame /2 ) - (y / 2) ;  
			
	}
	else if (x < xFrame && y < yFrame)
	{
		xPos = rectAfter.left + (xFrame - x) /2 ; 
		yPos = rectAfter.top  +  (yFrame - y ) /2; 
	}	
	else if(y < yFrame) 
	{
		yPos = rectAfter.top + (yFrame - y)/2 ; 
	}
	else if (x < xFrame) 
	{
	  
		xPos = rectAfter.left + (xFrame - x)/2 ;
	}	


}

void CUtils::BestFit(UINT srcX, UINT srcY, UINT maxX, UINT maxY, UINT &outX, UINT &outY) 
{
   
   double ratx = (double)srcX / (double)maxX;
   double raty = (double)srcY / (double)maxY;
	
    if (srcX < maxX && srcY < maxY) 
   {	
		outX = srcX ; 
		outY = srcY ; 
		return ;
   }
   if (ratx > raty) 
   {
	  outX = maxX;
       outY = (UINT)((double)srcY / ratx);
   } 
   else if (ratx < raty)
   {
      outX = (UINT)((double)srcX / raty);
      outY = maxY;
   } 
   else 
   {
      outX = maxX;
      outY = maxY;
   }
}

CString CUtils::GetResFile(LPCWSTR szFile) 
{
	CString strRet ; 
	
	LPWSTR lpCmdLine = GetCommandLine() ; 
	CString strPath = GetFullPath(lpCmdLine) ; 
	strPath.Remove('"'); 
	strRet = strPath + _T("skin") + _T("\\") + szFile; 
	//strRet.Format("%s%s%s%s%s",strPath,_T("\\"),_T("res"),_T("\\"),szFile) ; 
	return strRet ; 

}
CString CUtils::GetIconsFile(CString szFile)
{
	CString strRet ; 
	LPWSTR lpCmdLine = GetCommandLine() ; 
	CString strPath = GetFullPath(lpCmdLine) ; 
	strPath.Remove('"'); 
	strRet = strPath + _T("icon") + _T("\\") + szFile; 
	//strRet.Format("%s%s%s%s%s",strPath,_T("\\"),_T("res"),_T("\\"),szFile) ; 
	return strRet ; 

}
CString CUtils::GetAppPath() 
{
	CString strRet ; 
	LPWSTR lpCmdLine = GetCommandLine() ; 
	CString strPath = GetFullPath(lpCmdLine) ; 
	strPath.Remove('"'); 
	return strPath ; 

}

CString CUtils::GetFileExt(LPCWSTR path)
{
	CString strFileExt(path) ; 
	int idPos = strFileExt.ReverseFind('\\'); 
	CString fileExt = strFileExt.Right(strFileExt.GetLength() - (idPos+1)); 
	return fileExt ; 
}
CString CUtils::GetFileName(LPCWSTR path)
{
	CString strFileName(path) ; 
	int idPos = strFileName.ReverseFind('\\'); 
	CString fileExt = strFileName.Right(strFileName.GetLength() - (idPos+1)); 
	CString file = fileExt.Left(fileExt.ReverseFind('.')); 
	return file ; 
}
CString CUtils::GetFullPath(LPCWSTR path)
{
	CString strFileName(path) ; 
	int idPos = strFileName.ReverseFind('\\'); 
	return strFileName.Left(idPos + 1) ; 
}
 CString CUtils::GetExt(LPCWSTR path)
{
	CString strExt(path) ;
 	int idPos = strExt.ReverseFind('\\'); 
	CString fileExt = strExt.Right(strExt.GetLength() - (idPos+1)); 
	CString strExtension = fileExt.Right(fileExt.GetLength() - fileExt.ReverseFind('.')) ;
	return strExtension ; 

}


bool CUtils::IsSupportedFileType(CString strFileName)
{

	CFileManager manager ; 
	UINT uFileType = manager.GetFileType(strFileName) ;  
	bool bRetVal = false ; 

	switch(uFileType) {
	case IMAGE_TYPE_BMP : bRetVal = true ;break;
	case IMAGE_TYPE_JPG : bRetVal = true; break ; 
	case IMAGE_TYPE_TIFF: bRetVal = true; break ; 
	case IMAGE_TYPE_PNG : bRetVal = true; break ;
	case IMAGE_TYPE_PCX : bRetVal = true ; break ; 
	case IMAGE_TYPE_TGA : bRetVal = true ; break ; 
	
	}
	return bRetVal ; 
	
}
bool CUtils::OpenMailClient () 
{
	
	CString strCmdLine;
	CString strDefBrowser=_T("");
	HINSTANCE hRetVal= (HINSTANCE) 0;
	bool bRetVal = FALSE ; 
	
	STARTUPINFO startupinfo;
	PROCESS_INFORMATION proccinfo;
	GetStartupInfo(&startupinfo);
	startupinfo.dwFlags&=~STARTF_USESIZE;
	startupinfo.wShowWindow=SW_SHOWDEFAULT; 

		
	
	LPTSTR lpFileName;	
	LPTSTR lpCmdLine ; 
	CString cmd ("msimn.exe") ; 
	lpCmdLine = cmd.GetBuffer(1); 
	CString strBuild ; 
	strBuild = CUtils::LoadResourceString(IDS_BUILD)  ; 

	CString strMailto("mailto:info@dynamicinfoscreen.com?subject=Support request: Dynamic Info Screen ");
	strMailto += CUtils::LoadResourceString(IDS_APP_VERSION) ; 
	strMailto += " " ;
	strMailto += "(" ;
	strMailto += strBuild ; 
	strMailto += ")"; 
	lpFileName = strMailto.GetBuffer(1) ; 
	
	bRetVal = CreateProcess(NULL,lpCmdLine ,NULL,NULL,FALSE, NORMAL_PRIORITY_CLASS,NULL,NULL,&startupinfo,&proccinfo);
	cmd.ReleaseBuffer() ; 

	hRetVal=ShellExecute(NULL , _T("open"), lpFileName,NULL, NULL, SW_SHOW);
	bRetVal=32>(int)hRetVal;
	return bRetVal ; 
	return false ; 

}
bool CUtils::OpenInDefaultBrowser(CString strURL)
{
	CString strCmdLine;
	CString strDefBrowser=_T("");
	HINSTANCE hRetVal= (HINSTANCE) 0;

	strDefBrowser=GetDefaultBrowser1();

	STARTUPINFO startupinfo;
	PROCESS_INFORMATION proccinfo;
	GetStartupInfo(&startupinfo);
	startupinfo.dwFlags&=~STARTF_USESIZE;
	startupinfo.wShowWindow=SW_SHOWDEFAULT; 

	
	TCHAR lpBuffer[MAX_PATH];
	LPTSTR pFilePart;
	LPTSTR lpFileName;
	

	strURL=_T("\"")+strURL+_T("\"");

	
	bool bRetVal = FALSE;
	if (strDefBrowser!=_T(""))
	{

		lpFileName=strDefBrowser.GetBuffer(1);

		strDefBrowser.ReleaseBuffer(); 
		GetFullPathName(lpFileName,MAX_PATH,lpBuffer,&pFilePart);
		strDefBrowser=lpBuffer;
		strCmdLine=_T("\"")+strDefBrowser+_T("\" ")+ strURL;
		LPTSTR lpCmdLine=strCmdLine.GetBuffer(1);
		bRetVal = CreateProcess(NULL,lpCmdLine ,NULL,NULL,FALSE, NORMAL_PRIORITY_CLASS,NULL,NULL,&startupinfo,&proccinfo);
		strCmdLine.ReleaseBuffer(); 	
	}
	
	if(!bRetVal)//32>(int)hRetVal)
	{
		strDefBrowser=GetDefaultBrowser2();

		lpFileName=strDefBrowser.GetBuffer(1);
		strDefBrowser.ReleaseBuffer(); 
		GetFullPathName(lpFileName,MAX_PATH,lpBuffer,&pFilePart);
		strDefBrowser=lpBuffer;

		strCmdLine=_T("\"")+strDefBrowser+_T("\" ")+ strURL;
		LPTSTR lpCmdLine=strCmdLine.GetBuffer(1);

		bRetVal=CreateProcess(NULL,lpCmdLine ,NULL,NULL,FALSE, NORMAL_PRIORITY_CLASS,NULL,NULL,&startupinfo,&proccinfo);
		strCmdLine.ReleaseBuffer();
	}

	if(!bRetVal)//32>(int)hRetVal)
	{
		hRetVal=ShellExecute(NULL , _T("open"), strURL,NULL, NULL, SW_SHOW);
		bRetVal=32>(int)hRetVal;
	}

	return (bRetVal);//32>(int)hRetVal);
}



CString CUtils::GetDefaultBrowser1()
{
	
	CString brw=_T("");
	HKEY hKey;
	LONG lReturn;
	DWORD dwType, dwLength;
	TCHAR szBrowser[MAX_PATH];
	ZeroMemory(szBrowser,MAX_PATH);
	
	//opcija 1 // prvo trazimo kao kod cdr-a
	
	lReturn = RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("HTTP\\shell"), 0, KEY_QUERY_VALUE, &hKey);
	
	if(lReturn == ERROR_SUCCESS)
	{
		dwLength = sizeof(szBrowser);
		
		lReturn = RegQueryValueEx (hKey, _T(""), NULL, &dwType, (LPBYTE)szBrowser, &dwLength);
		CString strKey =_T("HTTP\\shell\\");
		strKey = strKey + szBrowser;
		strKey = strKey + _T("\\command");

		if(lReturn == ERROR_SUCCESS) 
		{
			lReturn = RegOpenKeyEx (HKEY_CLASSES_ROOT, strKey, 0, KEY_QUERY_VALUE, &hKey);
			ZeroMemory(szBrowser,MAX_PATH);
			dwLength = sizeof(szBrowser);
			if(lReturn == ERROR_SUCCESS)	
				lReturn = RegQueryValueEx (hKey, _T(""), NULL, &dwType, (LPBYTE)szBrowser, &dwLength);
			if(lReturn == ERROR_SUCCESS) 
			{
				brw=szBrowser;
				brw.TrimLeft(); 
				int nPos=brw.Find('\"');
				if (nPos=1)
				{
					brw.TrimLeft(_T("\""));
					nPos=brw.Find('\"');
					if(nPos!=-1)
						brw=brw.Left(nPos); 
				}
				brw.TrimLeft(); 
				brw.MakeLower(); 
				nPos=brw.Find(_T(".exe"));
				if(nPos!=-1)
						brw=brw.Left(nPos+4); 
			}

		}

	}
	return brw;

}
CString CUtils::GetDefaultBrowser2() 
{
	// a sad preko registry-ja
	
	CString brw=_T("");
	HKEY hKey;
	LONG lReturn;
	DWORD dwType, dwLength;
	TCHAR szBrowser[MAX_PATH];
	ZeroMemory(szBrowser,MAX_PATH);
	
	
	//opcija 2
	//a sad ako nismo nasli ko sto je kod cdr-a
	
	lReturn = RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("HTTP\\shell\\open\\command"), 0, KEY_QUERY_VALUE, &hKey);
	
	if(lReturn != ERROR_SUCCESS)
	{
		return _T("");
	}
	
	ZeroMemory(szBrowser,MAX_PATH);
	dwLength = sizeof(szBrowser);
	
	lReturn = RegQueryValueEx (hKey, _T(""), NULL,
		&dwType, (LPBYTE)szBrowser, &dwLength);
	
	brw=szBrowser;
	if(lReturn == ERROR_SUCCESS)	
	{
		brw=szBrowser;
		brw.TrimLeft(); 
		int nPos=brw.Find('\"');
		if (nPos=1)
		{
			brw.TrimLeft(_T("\""));
			nPos=brw.Find('\"');
			if(nPos!=-1)
				brw=brw.Left(nPos); 
		}
		brw.TrimLeft(); 
		brw.MakeLower(); 
		nPos=brw.Find(_T(".exe"));
		if(nPos!=-1)
			brw=brw.Left(nPos+4); 
		
	}
	
	return brw;
}