#pragma once

#include "FileManager.h" 
#include "shlobj.h"
#include "shellapi.h"


class CUtils
{
public:
	CUtils(void);
	~CUtils(void);

	CSize CalcAspectSize(CSize ptOriginalSize, CSize ptWantedSize);
	CSize CalcAspectSizeMN(CSize ptOriginalSize, CSize ptWantedSize);
	bool IsPortrait(CSize ptImageSize);
   	
	static CString GetExt(LPCWSTR path);
	static CString GetFullPath(LPCWSTR path);
	static CString GetFileExt(LPCWSTR path);
	static CString GetFileName(LPCWSTR path); 
	
	static CBitmap* LoadBitmapEx(LPCWSTR lpsFileName) ; 
	static HGLOBAL GetBackGround(LPCWSTR lpsFileName) ;
	static void PreMultiplyRGBChannels(LPBYTE hImg,UINT32& w,UINT32& h); 


	static HRGN DIBToRgn(HBITMAP hBmp, COLORREF BkColor,BOOL Direct);
	static HRGN BitmapToRegion (HBITMAP hBmp, COLORREF cTransparentColor, COLORREF cTolerance);

	static bool CreateFileEx (LPCWSTR pszFileName) ; 
	static void GetShortPathName(LPCWSTR pszFileName,LPWSTR pszOut) ;
	static bool FileExists(LPCWSTR szFileName) ; 
	
	static CString GetResFile(LPCWSTR szFile) ; 
	static CString GetIconsFile(CString strFile); 
	static CString GetAppPath() ; 

	static void GetDefaultFont(CFont& font) ; 
	static void GetNamedFont(CFont& font,LPCWSTR szFontName,LONG lSize,LONG lBold) ;
	
	
	static CString LoadResourceString(int iResID);
	static CComBSTR LoadResourceStringEx(int iResID);
	static CString LoadResourceHTML (int iResID) ; 

	static void CenterImage (UINT x,UINT y, CRect& rectAfter,UINT& xPos , UINT& yPos) ;
	static void BestFit(UINT srcX, UINT srcY, UINT maxX, UINT maxY, UINT &outX, UINT &outY) ;
	static bool IsSupportedFileType(CString strFileName) ; 
	static bool OpenMailClient () ;
	static bool OpenInDefaultBrowser(CString strURL);
	static CString GetDefaultBrowser1() ; 
	static CString GetDefaultBrowser2() ;





    

};
